package com.sun.org.apache.xerces.internal.impl.xs;

import java.util.ArrayList;
import java.util.Stack;
import com.sun.org.apache.xerces.internal.impl.xs.identity.KeyRef;
import com.sun.org.apache.xerces.internal.impl.xs.identity.UniqueOrKey;
import com.sun.org.apache.xerces.internal.xs.ShortList;
import com.sun.org.apache.xerces.internal.util.IntStack;
import java.util.Vector;
import jdk.xml.internal.JdkXmlUtils;
import com.sun.org.apache.xerces.internal.util.XMLAttributesImpl;
import com.sun.org.apache.xerces.internal.impl.dv.xs.XSSimpleTypeDecl;
import com.sun.org.apache.xerces.internal.xs.XSObjectList;
import com.sun.org.apache.xerces.internal.impl.xs.util.XS10TypeHelper;
import com.sun.org.apache.xerces.internal.impl.dv.InvalidDatatypeValueException;
import com.sun.org.apache.xerces.internal.xs.StringList;
import com.sun.org.apache.xerces.internal.xni.parser.XMLInputSource;
import java.io.IOException;
import java.util.Collections;
import com.sun.org.apache.xerces.internal.util.URI;
import com.sun.org.apache.xerces.internal.impl.XMLEntityManager;
import com.sun.org.apache.xerces.internal.util.XMLSymbols;
import java.util.Iterator;
import java.util.List;
import com.sun.org.apache.xerces.internal.impl.dv.DatatypeException;
import com.sun.org.apache.xerces.internal.impl.xs.identity.Selector;
import com.sun.org.apache.xerces.internal.impl.xs.identity.ValueStore;
import com.sun.org.apache.xerces.internal.impl.xs.identity.XPathMatcher;
import com.sun.org.apache.xerces.internal.impl.xs.identity.Field;
import com.sun.org.apache.xerces.internal.impl.xs.identity.IdentityConstraint;
import com.sun.org.apache.xerces.internal.impl.XMLErrorReporter;
import com.sun.org.apache.xerces.internal.xni.parser.XMLComponentManager;
import java.util.HashMap;
import com.sun.org.apache.xerces.internal.xni.XMLResourceIdentifier;
import com.sun.org.apache.xerces.internal.util.XMLChar;
import com.sun.org.apache.xerces.internal.xni.XMLAttributes;
import com.sun.org.apache.xerces.internal.xni.XNIException;
import com.sun.org.apache.xerces.internal.xni.Augmentations;
import com.sun.org.apache.xerces.internal.xni.NamespaceContext;
import com.sun.org.apache.xerces.internal.parsers.XMLParser;
import com.sun.org.apache.xerces.internal.xni.parser.XMLConfigurationException;
import com.sun.org.apache.xerces.internal.impl.validation.ValidationState;
import com.sun.org.apache.xerces.internal.impl.dv.ValidatedInfo;
import com.sun.org.apache.xerces.internal.xni.QName;
import com.sun.org.apache.xerces.internal.impl.xs.models.XSCMValidator;
import com.sun.org.apache.xerces.internal.xs.XSTypeDefinition;
import com.sun.org.apache.xerces.internal.impl.xs.models.CMBuilder;
import com.sun.org.apache.xerces.internal.impl.xs.models.CMNodeFactory;
import com.sun.org.apache.xerces.internal.impl.dv.XSSimpleType;
import com.sun.org.apache.xerces.internal.xni.parser.XMLDocumentSource;
import com.sun.org.apache.xerces.internal.xni.XMLDocumentHandler;
import java.util.Map;
import com.sun.org.apache.xerces.internal.xni.grammars.XMLGrammarPool;
import com.sun.org.apache.xerces.internal.impl.validation.ConfigurableValidationState;
import com.sun.org.apache.xerces.internal.impl.validation.ValidationManager;
import com.sun.org.apache.xerces.internal.xni.parser.XMLEntityResolver;
import com.sun.org.apache.xerces.internal.xni.XMLLocator;
import com.sun.org.apache.xerces.internal.util.SymbolTable;
import com.sun.org.apache.xerces.internal.xni.XMLString;
import com.sun.org.apache.xerces.internal.util.AugmentationsImpl;
import com.sun.org.apache.xerces.internal.impl.RevalidationHandler;
import com.sun.org.apache.xerces.internal.impl.xs.identity.FieldActivator;
import com.sun.org.apache.xerces.internal.xni.parser.XMLDocumentFilter;
import com.sun.org.apache.xerces.internal.xni.parser.XMLComponent;

public class XMLSchemaValidator implements XMLComponent, XMLDocumentFilter, FieldActivator, RevalidationHandler, XSElementDeclHelper
{
    private static final boolean DEBUG = false;
    protected static final String VALIDATION = "http://xml.org/sax/features/validation";
    protected static final String SCHEMA_VALIDATION = "http://apache.org/xml/features/validation/schema";
    protected static final String SCHEMA_FULL_CHECKING = "http://apache.org/xml/features/validation/schema-full-checking";
    protected static final String DYNAMIC_VALIDATION = "http://apache.org/xml/features/validation/dynamic";
    protected static final String NORMALIZE_DATA = "http://apache.org/xml/features/validation/schema/normalized-value";
    protected static final String SCHEMA_ELEMENT_DEFAULT = "http://apache.org/xml/features/validation/schema/element-default";
    protected static final String SCHEMA_AUGMENT_PSVI = "http://apache.org/xml/features/validation/schema/augment-psvi";
    protected static final String ALLOW_JAVA_ENCODINGS = "http://apache.org/xml/features/allow-java-encodings";
    protected static final String STANDARD_URI_CONFORMANT_FEATURE = "http://apache.org/xml/features/standard-uri-conformant";
    protected static final String GENERATE_SYNTHETIC_ANNOTATIONS = "http://apache.org/xml/features/generate-synthetic-annotations";
    protected static final String VALIDATE_ANNOTATIONS = "http://apache.org/xml/features/validate-annotations";
    protected static final String HONOUR_ALL_SCHEMALOCATIONS = "http://apache.org/xml/features/honour-all-schemaLocations";
    protected static final String USE_GRAMMAR_POOL_ONLY = "http://apache.org/xml/features/internal/validation/schema/use-grammar-pool-only";
    protected static final String CONTINUE_AFTER_FATAL_ERROR = "http://apache.org/xml/features/continue-after-fatal-error";
    protected static final String PARSER_SETTINGS = "http://apache.org/xml/features/internal/parser-settings";
    protected static final String NAMESPACE_GROWTH = "http://apache.org/xml/features/namespace-growth";
    protected static final String TOLERATE_DUPLICATES = "http://apache.org/xml/features/internal/tolerate-duplicates";
    protected static final String IGNORE_XSI_TYPE = "http://apache.org/xml/features/validation/schema/ignore-xsi-type-until-elemdecl";
    protected static final String ID_IDREF_CHECKING = "http://apache.org/xml/features/validation/id-idref-checking";
    protected static final String UNPARSED_ENTITY_CHECKING = "http://apache.org/xml/features/validation/unparsed-entity-checking";
    protected static final String IDENTITY_CONSTRAINT_CHECKING = "http://apache.org/xml/features/validation/identity-constraint-checking";
    protected static final String REPORT_WHITESPACE = "http://java.sun.com/xml/schema/features/report-ignored-element-content-whitespace";
    public static final String SYMBOL_TABLE = "http://apache.org/xml/properties/internal/symbol-table";
    public static final String ERROR_REPORTER = "http://apache.org/xml/properties/internal/error-reporter";
    public static final String ENTITY_RESOLVER = "http://apache.org/xml/properties/internal/entity-resolver";
    public static final String XMLGRAMMAR_POOL = "http://apache.org/xml/properties/internal/grammar-pool";
    protected static final String VALIDATION_MANAGER = "http://apache.org/xml/properties/internal/validation-manager";
    protected static final String ENTITY_MANAGER = "http://apache.org/xml/properties/internal/entity-manager";
    protected static final String SCHEMA_LOCATION = "http://apache.org/xml/properties/schema/external-schemaLocation";
    protected static final String SCHEMA_NONS_LOCATION = "http://apache.org/xml/properties/schema/external-noNamespaceSchemaLocation";
    protected static final String JAXP_SCHEMA_SOURCE = "http://java.sun.com/xml/jaxp/properties/schemaSource";
    protected static final String JAXP_SCHEMA_LANGUAGE = "http://java.sun.com/xml/jaxp/properties/schemaLanguage";
    protected static final String ROOT_TYPE_DEF = "http://apache.org/xml/properties/validation/schema/root-type-definition";
    protected static final String ROOT_ELEMENT_DECL = "http://apache.org/xml/properties/validation/schema/root-element-declaration";
    protected static final String SCHEMA_DV_FACTORY = "http://apache.org/xml/properties/internal/validation/schema/dv-factory";
    private static final String XML_SECURITY_PROPERTY_MANAGER = "http://www.oracle.com/xml/jaxp/properties/xmlSecurityPropertyManager";
    protected static final String OVERRIDE_PARSER = "jdk.xml.overrideDefaultParser";
    private static final String[] RECOGNIZED_FEATURES;
    private static final Boolean[] FEATURE_DEFAULTS;
    private static final String[] RECOGNIZED_PROPERTIES;
    private static final Object[] PROPERTY_DEFAULTS;
    protected static final int ID_CONSTRAINT_NUM = 1;
    static final XSAttributeDecl XSI_TYPE;
    static final XSAttributeDecl XSI_NIL;
    static final XSAttributeDecl XSI_SCHEMALOCATION;
    static final XSAttributeDecl XSI_NONAMESPACESCHEMALOCATION;
    protected ElementPSVImpl fCurrentPSVI;
    protected final AugmentationsImpl fAugmentations;
    protected XMLString fDefaultValue;
    protected boolean fDynamicValidation;
    protected boolean fSchemaDynamicValidation;
    protected boolean fDoValidation;
    protected boolean fFullChecking;
    protected boolean fNormalizeData;
    protected boolean fSchemaElementDefault;
    protected boolean fAugPSVI;
    protected boolean fIdConstraint;
    protected boolean fUseGrammarPoolOnly;
    protected boolean fNamespaceGrowth;
    private String fSchemaType;
    protected boolean fEntityRef;
    protected boolean fInCDATA;
    protected boolean fSawOnlyWhitespaceInElementContent;
    protected SymbolTable fSymbolTable;
    private XMLLocator fLocator;
    protected final XMLSchemaValidator.XSIErrorReporter fXSIErrorReporter;
    protected XMLEntityResolver fEntityResolver;
    protected ValidationManager fValidationManager;
    protected ConfigurableValidationState fValidationState;
    protected XMLGrammarPool fGrammarPool;
    protected String fExternalSchemas;
    protected String fExternalNoNamespaceSchema;
    protected Object fJaxpSchemaSource;
    protected final XSDDescription fXSDDescription;
    protected final Map<String, XMLSchemaLoader.LocationArray> fLocationPairs;
    protected XMLDocumentHandler fDocumentHandler;
    protected XMLDocumentSource fDocumentSource;
    boolean reportWhitespace;
    static final int INITIAL_STACK_SIZE = 8;
    static final int INC_STACK_SIZE = 8;
    private static final boolean DEBUG_NORMALIZATION = false;
    private final XMLString fEmptyXMLStr;
    private static final int BUFFER_SIZE = 20;
    private final XMLString fNormalizedStr;
    private boolean fFirstChunk;
    private boolean fTrailing;
    private short fWhiteSpace;
    private boolean fUnionType;
    private final XSGrammarBucket fGrammarBucket;
    private final SubstitutionGroupHandler fSubGroupHandler;
    private final XSSimpleType fQNameDV;
    private final CMNodeFactory nodeFactory;
    private final CMBuilder fCMBuilder;
    private final XMLSchemaLoader fSchemaLoader;
    private String fValidationRoot;
    private int fSkipValidationDepth;
    private int fNFullValidationDepth;
    private int fNNoneValidationDepth;
    private int fElementDepth;
    private boolean fSubElement;
    private boolean[] fSubElementStack;
    private XSElementDecl fCurrentElemDecl;
    private XSElementDecl[] fElemDeclStack;
    private boolean fNil;
    private boolean[] fNilStack;
    private XSNotationDecl fNotation;
    private XSNotationDecl[] fNotationStack;
    private XSTypeDefinition fCurrentType;
    private XSTypeDefinition[] fTypeStack;
    private XSCMValidator fCurrentCM;
    private XSCMValidator[] fCMStack;
    private int[] fCurrCMState;
    private int[][] fCMStateStack;
    private boolean fStrictAssess;
    private boolean[] fStrictAssessStack;
    private final StringBuilder fBuffer;
    private boolean fAppendBuffer;
    private boolean fSawText;
    private boolean[] fSawTextStack;
    private boolean fSawCharacters;
    private boolean[] fStringContent;
    private final QName fTempQName;
    private javax.xml.namespace.QName fRootTypeQName;
    private XSTypeDefinition fRootTypeDefinition;
    private javax.xml.namespace.QName fRootElementDeclQName;
    private XSElementDecl fRootElementDeclaration;
    private int fIgnoreXSITypeDepth;
    private boolean fIDCChecking;
    private ValidatedInfo fValidatedInfo;
    private ValidationState fState4XsiType;
    private ValidationState fState4ApplyDefault;
    protected XMLSchemaValidator.XPathMatcherStack fMatcherStack;
    protected XMLSchemaValidator.ValueStoreCache fValueStoreCache;
    
    @Override
    public String[] getRecognizedFeatures() {
        return (String[])(String[])XMLSchemaValidator.RECOGNIZED_FEATURES.clone();
    }
    
    @Override
    public void setFeature(String featureId, boolean state) throws XMLConfigurationException {
    }
    
    @Override
    public String[] getRecognizedProperties() {
        return (String[])(String[])XMLSchemaValidator.RECOGNIZED_PROPERTIES.clone();
    }
    
    @Override
    public void setProperty(String propertyId, Object value) throws XMLConfigurationException {
        if (propertyId.equals("http://apache.org/xml/properties/validation/schema/root-type-definition")) {
            if (value == null) {
                this.fRootTypeQName = null;
                this.fRootTypeDefinition = null;
            }
            else if ((value instanceof javax.xml.namespace.QName)) {
                this.fRootTypeQName = (javax.xml.namespace.QName)value;
                this.fRootTypeDefinition = null;
            }
            else {
                this.fRootTypeDefinition = (XSTypeDefinition)value;
                this.fRootTypeQName = null;
            }
        }
        else if (propertyId.equals("http://apache.org/xml/properties/validation/schema/root-element-declaration")) {
            if (value == null) {
                this.fRootElementDeclQName = null;
                this.fRootElementDeclaration = null;
            }
            else if ((value instanceof javax.xml.namespace.QName)) {
                this.fRootElementDeclQName = (javax.xml.namespace.QName)value;
                this.fRootElementDeclaration = null;
            }
            else {
                this.fRootElementDeclaration = (XSElementDecl)value;
                this.fRootElementDeclQName = null;
            }
        }
    }
    
    @Override
    public Boolean getFeatureDefault(String featureId) {
        int i = 0;
        while (i < XMLSchemaValidator.RECOGNIZED_FEATURES.length) {
            if (XMLSchemaValidator.RECOGNIZED_FEATURES[i].equals(featureId)) {
                return XMLSchemaValidator.FEATURE_DEFAULTS[i];
            }
            ++i;
        }
        return null;
    }
    
    @Override
    public Object getPropertyDefault(String propertyId) {
        int i = 0;
        while (i < XMLSchemaValidator.RECOGNIZED_PROPERTIES.length) {
            if (XMLSchemaValidator.RECOGNIZED_PROPERTIES[i].equals(propertyId)) {
                return XMLSchemaValidator.PROPERTY_DEFAULTS[i];
            }
            ++i;
        }
        return null;
    }
    
    @Override
    public void setDocumentHandler(XMLDocumentHandler documentHandler) {
        this.fDocumentHandler = documentHandler;
        if ((documentHandler instanceof XMLParser)) {
            try {
                this.reportWhitespace = ((XMLParser)documentHandler).getFeature("http://java.sun.com/xml/schema/features/report-ignored-element-content-whitespace");
            }
            catch (Exception e) {
                this.reportWhitespace = false;
            }
        }
    }
    
    @Override
    public XMLDocumentHandler getDocumentHandler() {
        return this.fDocumentHandler;
    }
    
    @Override
    public void setDocumentSource(XMLDocumentSource source) {
        this.fDocumentSource = source;
    }
    
    @Override
    public XMLDocumentSource getDocumentSource() {
        return this.fDocumentSource;
    }
    
    @Override
    public void startDocument(XMLLocator locator, String encoding, NamespaceContext namespaceContext, Augmentations augs) throws XNIException {
        this.fValidationState.setNamespaceSupport(namespaceContext);
        this.fState4XsiType.setNamespaceSupport(namespaceContext);
        this.fState4ApplyDefault.setNamespaceSupport(namespaceContext);
        this.handleStartDocument(this.fLocator = locator, encoding);
        if (this.fDocumentHandler != null) {
            this.fDocumentHandler.startDocument(locator, encoding, namespaceContext, augs);
        }
    }
    
    @Override
    public void xmlDecl(String version, String encoding, String standalone, Augmentations augs) throws XNIException {
        if (this.fDocumentHandler != null) {
            this.fDocumentHandler.xmlDecl(version, encoding, standalone, augs);
        }
    }
    
    @Override
    public void doctypeDecl(String rootElement, String publicId, String systemId, Augmentations augs) throws XNIException {
        if (this.fDocumentHandler != null) {
            this.fDocumentHandler.doctypeDecl(rootElement, publicId, systemId, augs);
        }
    }
    
    @Override
    public void startElement(QName element, XMLAttributes attributes, Augmentations augs) throws XNIException {
        Augmentations modifiedAugs = this.handleStartElement(element, attributes, augs);
        if (this.fDocumentHandler != null) {
            this.fDocumentHandler.startElement(element, attributes, modifiedAugs);
        }
    }
    
    @Override
    public void emptyElement(QName element, XMLAttributes attributes, Augmentations augs) throws XNIException {
        Augmentations modifiedAugs = this.handleStartElement(element, attributes, augs);
        this.fDefaultValue = null;
        if (this.fElementDepth != -2) {
            modifiedAugs = this.handleEndElement(element, modifiedAugs);
        }
        if (this.fDocumentHandler != null) {
            if (!this.fSchemaElementDefault || this.fDefaultValue == null) {
                this.fDocumentHandler.emptyElement(element, attributes, modifiedAugs);
            }
            else {
                this.fDocumentHandler.startElement(element, attributes, modifiedAugs);
                this.fDocumentHandler.characters(this.fDefaultValue, null);
                this.fDocumentHandler.endElement(element, modifiedAugs);
            }
        }
    }
    
    @Override
    public void characters(XMLString text, Augmentations augs) throws XNIException {
        text = this.handleCharacters(text);
        if (this.fSawOnlyWhitespaceInElementContent) {
            this.fSawOnlyWhitespaceInElementContent = false;
            if (!this.reportWhitespace) {
                this.ignorableWhitespace(text, augs);
                return;
            }
        }
        if (this.fDocumentHandler != null) {
            if (this.fNormalizeData && this.fUnionType) {
                if (augs != null) {
                    this.fDocumentHandler.characters(this.fEmptyXMLStr, augs);
                }
            }
            else {
                this.fDocumentHandler.characters(text, augs);
            }
        }
    }
    
    @Override
    public void ignorableWhitespace(XMLString text, Augmentations augs) throws XNIException {
        this.handleIgnorableWhitespace(text);
        if (this.fDocumentHandler != null) {
            this.fDocumentHandler.ignorableWhitespace(text, augs);
        }
    }
    
    @Override
    public void endElement(QName element, Augmentations augs) throws XNIException {
        this.fDefaultValue = null;
        Augmentations modifiedAugs = this.handleEndElement(element, augs);
        if (this.fDocumentHandler != null) {
            if (!this.fSchemaElementDefault || this.fDefaultValue == null) {
                this.fDocumentHandler.endElement(element, modifiedAugs);
            }
            else {
                this.fDocumentHandler.characters(this.fDefaultValue, null);
                this.fDocumentHandler.endElement(element, modifiedAugs);
            }
        }
    }
    
    @Override
    public void startCDATA(Augmentations augs) throws XNIException {
        this.fInCDATA = true;
        if (this.fDocumentHandler != null) {
            this.fDocumentHandler.startCDATA(augs);
        }
    }
    
    @Override
    public void endCDATA(Augmentations augs) throws XNIException {
        this.fInCDATA = false;
        if (this.fDocumentHandler != null) {
            this.fDocumentHandler.endCDATA(augs);
        }
    }
    
    @Override
    public void endDocument(Augmentations augs) throws XNIException {
        this.handleEndDocument();
        if (this.fDocumentHandler != null) {
            this.fDocumentHandler.endDocument(augs);
        }
        this.fLocator = null;
    }
    
    @Override
    public boolean characterData(String data, Augmentations augs) {
        this.fSawText = (this.fSawText || data.length() > 0);
        if (this.fNormalizeData && this.fWhiteSpace != -1 && this.fWhiteSpace != 0) {
            this.normalizeWhitespace(data, this.fWhiteSpace == 2);
            this.fBuffer.append(this.fNormalizedStr.ch, this.fNormalizedStr.offset, this.fNormalizedStr.length);
        }
        else if (this.fAppendBuffer) {
            this.fBuffer.append(data);
        }
        boolean allWhiteSpace = true;
        if (this.fCurrentType != null && this.fCurrentType.getTypeCategory() == 15) {
            XSComplexTypeDecl ctype = (XSComplexTypeDecl)this.fCurrentType;
            if (ctype.fContentType == 2) {
                int i = 0;
                while (i < data.length()) {
                    if (!XMLChar.isSpace((int)data.charAt(i))) {
                        allWhiteSpace = false;
                        this.fSawCharacters = true;
                        break;
                    }
                    ++i;
                }
            }
        }
        return allWhiteSpace;
    }
    
    public void elementDefault(String data) {
    }
    
    @Override
    public void startGeneralEntity(String name, XMLResourceIdentifier identifier, String encoding, Augmentations augs) throws XNIException {
        this.fEntityRef = true;
        if (this.fDocumentHandler != null) {
            this.fDocumentHandler.startGeneralEntity(name, identifier, encoding, augs);
        }
    }
    
    @Override
    public void textDecl(String version, String encoding, Augmentations augs) throws XNIException {
        if (this.fDocumentHandler != null) {
            this.fDocumentHandler.textDecl(version, encoding, augs);
        }
    }
    
    @Override
    public void comment(XMLString text, Augmentations augs) throws XNIException {
        if (this.fDocumentHandler != null) {
            this.fDocumentHandler.comment(text, augs);
        }
    }
    
    @Override
    public void processingInstruction(String target, XMLString data, Augmentations augs) throws XNIException {
        if (this.fDocumentHandler != null) {
            this.fDocumentHandler.processingInstruction(target, data, augs);
        }
    }
    
    @Override
    public void endGeneralEntity(String name, Augmentations augs) throws XNIException {
        this.fEntityRef = false;
        if (this.fDocumentHandler != null) {
            this.fDocumentHandler.endGeneralEntity(name, augs);
        }
    }
    
    public XMLSchemaValidator() {
        this.fCurrentPSVI = new ElementPSVImpl();
        this.fAugmentations = new AugmentationsImpl();
        this.fDynamicValidation = false;
        this.fSchemaDynamicValidation = false;
        this.fDoValidation = false;
        this.fFullChecking = false;
        this.fNormalizeData = true;
        this.fSchemaElementDefault = true;
        this.fAugPSVI = true;
        this.fIdConstraint = false;
        this.fUseGrammarPoolOnly = false;
        this.fNamespaceGrowth = false;
        this.fSchemaType = null;
        this.fEntityRef = false;
        this.fInCDATA = false;
        this.fSawOnlyWhitespaceInElementContent = false;
        this.fXSIErrorReporter = new XMLSchemaValidator.XSIErrorReporter();
        this.fValidationManager = null;
        this.fValidationState = new ConfigurableValidationState();
        this.fExternalSchemas = null;
        this.fExternalNoNamespaceSchema = null;
        this.fJaxpSchemaSource = null;
        this.fXSDDescription = new XSDDescription();
        this.fLocationPairs = new HashMap();
        this.reportWhitespace = false;
        this.fEmptyXMLStr = new XMLString(null, 0, -1);
        this.fNormalizedStr = new XMLString();
        this.fFirstChunk = true;
        this.fTrailing = false;
        this.fWhiteSpace = -1;
        this.fUnionType = false;
        this.fGrammarBucket = new XSGrammarBucket();
        this.fSubGroupHandler = new SubstitutionGroupHandler(this);
        this.fQNameDV = (XSSimpleType)SchemaGrammar.SG_SchemaNS.getGlobalTypeDecl("QName");
        this.nodeFactory = new CMNodeFactory();
        this.fCMBuilder = new CMBuilder(this.nodeFactory);
        this.fSchemaLoader = new XMLSchemaLoader(this.fXSIErrorReporter.fErrorReporter, this.fGrammarBucket, this.fSubGroupHandler, this.fCMBuilder);
        this.fSubElementStack = new boolean[8];
        this.fElemDeclStack = new XSElementDecl[8];
        this.fNilStack = new boolean[8];
        this.fNotationStack = new XSNotationDecl[8];
        this.fTypeStack = new XSTypeDefinition[8];
        this.fCMStack = new XSCMValidator[8];
        this.fCMStateStack = new int[8][];
        this.fStrictAssess = true;
        this.fStrictAssessStack = new boolean[8];
        this.fBuffer = new StringBuilder();
        this.fAppendBuffer = true;
        this.fSawText = false;
        this.fSawTextStack = new boolean[8];
        this.fSawCharacters = false;
        this.fStringContent = new boolean[8];
        this.fTempQName = new QName();
        this.fRootTypeQName = null;
        this.fRootTypeDefinition = null;
        this.fRootElementDeclQName = null;
        this.fRootElementDeclaration = null;
        this.fValidatedInfo = new ValidatedInfo();
        this.fState4XsiType = new ValidationState();
        this.fState4ApplyDefault = new ValidationState();
        this.fMatcherStack = new XMLSchemaValidator.XPathMatcherStack();
        this.fValueStoreCache = new XMLSchemaValidator.ValueStoreCache();
        this.fState4XsiType.setExtraChecking(false);
        this.fState4ApplyDefault.setFacetChecking(false);
    }
    
    @Override
    public void reset(XMLComponentManager componentManager) throws XMLConfigurationException {
        this.fIdConstraint = false;
        this.fLocationPairs.clear();
        this.fValidationState.resetIDTables();
        this.fSchemaLoader.reset(componentManager);
        this.fCurrentElemDecl = null;
        this.fCurrentCM = null;
        this.fCurrCMState = null;
        this.fSkipValidationDepth = -1;
        this.fNFullValidationDepth = -1;
        this.fNNoneValidationDepth = -1;
        this.fElementDepth = -1;
        this.fSubElement = false;
        this.fSchemaDynamicValidation = false;
        this.fEntityRef = false;
        this.fInCDATA = false;
        this.fMatcherStack.clear();
        this.fXSIErrorReporter.reset((XMLErrorReporter)componentManager.getProperty("http://apache.org/xml/properties/internal/error-reporter"));
        boolean parser_settings = componentManager.getFeature("http://apache.org/xml/features/internal/parser-settings", true);
        if (!parser_settings) {
            this.fValidationManager.addValidationState(this.fValidationState);
            this.nodeFactory.reset();
            XMLSchemaLoader.processExternalHints(this.fExternalSchemas, this.fExternalNoNamespaceSchema, this.fLocationPairs, this.fXSIErrorReporter.fErrorReporter);
            return;
        }
        this.nodeFactory.reset(componentManager);
        SymbolTable symbolTable = (SymbolTable)componentManager.getProperty("http://apache.org/xml/properties/internal/symbol-table");
        if (symbolTable != this.fSymbolTable) {
            this.fSymbolTable = symbolTable;
        }
        this.fNamespaceGrowth = componentManager.getFeature("http://apache.org/xml/features/namespace-growth", false);
        this.fDynamicValidation = componentManager.getFeature("http://apache.org/xml/features/validation/dynamic", false);
        if (this.fDynamicValidation) {
            this.fDoValidation = true;
        }
        else {
            this.fDoValidation = componentManager.getFeature("http://xml.org/sax/features/validation", false);
        }
        if (this.fDoValidation) {
            this.fDoValidation |= componentManager.getFeature("http://apache.org/xml/features/validation/schema", false);
        }
        this.fFullChecking = componentManager.getFeature("http://apache.org/xml/features/validation/schema-full-checking", false);
        this.fNormalizeData = componentManager.getFeature("http://apache.org/xml/features/validation/schema/normalized-value", false);
        this.fSchemaElementDefault = componentManager.getFeature("http://apache.org/xml/features/validation/schema/element-default", false);
        this.fAugPSVI = componentManager.getFeature("http://apache.org/xml/features/validation/schema/augment-psvi", true);
        this.fSchemaType = (String)componentManager.getProperty("http://java.sun.com/xml/jaxp/properties/schemaLanguage", null);
        this.fUseGrammarPoolOnly = componentManager.getFeature("http://apache.org/xml/features/internal/validation/schema/use-grammar-pool-only", false);
        this.fEntityResolver = (XMLEntityResolver)componentManager.getProperty("http://apache.org/xml/properties/internal/entity-manager");
        (this.fValidationManager = (ValidationManager)componentManager.getProperty("http://apache.org/xml/properties/internal/validation-manager")).addValidationState(this.fValidationState);
        this.fValidationState.setSymbolTable(this.fSymbolTable);
        try {
            Object rootType = componentManager.getProperty("http://apache.org/xml/properties/validation/schema/root-type-definition");
            if (rootType == null) {
                this.fRootTypeQName = null;
                this.fRootTypeDefinition = null;
            }
            else if ((rootType instanceof javax.xml.namespace.QName)) {
                this.fRootTypeQName = (javax.xml.namespace.QName)rootType;
                this.fRootTypeDefinition = null;
            }
            else {
                this.fRootTypeDefinition = (XSTypeDefinition)rootType;
                this.fRootTypeQName = null;
            }
        }
        catch (XMLConfigurationException e) {
            this.fRootTypeQName = null;
            this.fRootTypeDefinition = null;
        }
        try {
            Object rootDecl = componentManager.getProperty("http://apache.org/xml/properties/validation/schema/root-element-declaration");
            if (rootDecl == null) {
                this.fRootElementDeclQName = null;
                this.fRootElementDeclaration = null;
            }
            else if ((rootDecl instanceof javax.xml.namespace.QName)) {
                this.fRootElementDeclQName = (javax.xml.namespace.QName)rootDecl;
                this.fRootElementDeclaration = null;
            }
            else {
                this.fRootElementDeclaration = (XSElementDecl)rootDecl;
                this.fRootElementDeclQName = null;
            }
        }
        catch (XMLConfigurationException e) {
            this.fRootElementDeclQName = null;
            this.fRootElementDeclaration = null;
        }
        boolean ignoreXSIType = componentManager.getFeature("http://apache.org/xml/features/validation/schema/ignore-xsi-type-until-elemdecl", false);
        this.fIgnoreXSITypeDepth = (ignoreXSIType ? 0 : -1);
        try {
            this.fIDCChecking = componentManager.getFeature("http://apache.org/xml/features/validation/identity-constraint-checking");
        }
        catch (XMLConfigurationException e2) {
            this.fIDCChecking = true;
        }
        try {
            this.fValidationState.setIdIdrefChecking(componentManager.getFeature("http://apache.org/xml/features/validation/id-idref-checking"));
        }
        catch (XMLConfigurationException e2) {
            this.fValidationState.setIdIdrefChecking(true);
        }
        try {
            this.fValidationState.setUnparsedEntityChecking(componentManager.getFeature("http://apache.org/xml/features/validation/unparsed-entity-checking"));
        }
        catch (XMLConfigurationException e2) {
            this.fValidationState.setUnparsedEntityChecking(true);
        }
        try {
            this.fExternalSchemas = (String)componentManager.getProperty("http://apache.org/xml/properties/schema/external-schemaLocation");
            this.fExternalNoNamespaceSchema = (String)componentManager.getProperty("http://apache.org/xml/properties/schema/external-noNamespaceSchemaLocation");
        }
        catch (XMLConfigurationException e2) {
            this.fExternalSchemas = null;
            this.fExternalNoNamespaceSchema = null;
        }
        XMLSchemaLoader.processExternalHints(this.fExternalSchemas, this.fExternalNoNamespaceSchema, this.fLocationPairs, this.fXSIErrorReporter.fErrorReporter);
        this.fJaxpSchemaSource = componentManager.getProperty("http://java.sun.com/xml/jaxp/properties/schemaSource", null);
        this.fGrammarPool = (XMLGrammarPool)componentManager.getProperty("http://apache.org/xml/properties/internal/grammar-pool", null);
        this.fState4XsiType.setSymbolTable(symbolTable);
        this.fState4ApplyDefault.setSymbolTable(symbolTable);
        return;
    }
    
    @Override
    public void startValueScopeFor(IdentityConstraint identityConstraint, int initialDepth) {
        XMLSchemaValidator.ValueStoreBase valueStore = this.fValueStoreCache.getValueStoreFor(identityConstraint, initialDepth);
        valueStore.startValueScope();
    }
    
    @Override
    public XPathMatcher activateField(Field field, int initialDepth) {
        ValueStore valueStore = this.fValueStoreCache.getValueStoreFor(field.getIdentityConstraint(), initialDepth);
        XPathMatcher matcher = field.createMatcher(valueStore);
        this.fMatcherStack.addMatcher(matcher);
        matcher.startDocumentFragment();
        return matcher;
    }
    
    @Override
    public void endValueScopeFor(IdentityConstraint identityConstraint, int initialDepth) {
        XMLSchemaValidator.ValueStoreBase valueStore = this.fValueStoreCache.getValueStoreFor(identityConstraint, initialDepth);
        valueStore.endValueScope();
    }
    
    private void activateSelectorFor(IdentityConstraint ic) {
        Selector selector = ic.getSelector();
        FieldActivator activator = this;
        if (selector == null) {
            return;
        }
        XPathMatcher matcher = selector.createMatcher(activator, this.fElementDepth);
        this.fMatcherStack.addMatcher(matcher);
        matcher.startDocumentFragment();
        return;
    }
    
    @Override
    public XSElementDecl getGlobalElementDecl(QName element) {
        SchemaGrammar sGrammar = this.findSchemaGrammar((short)5, element.uri, null, element, null);
        if (sGrammar != null) {
            return sGrammar.getGlobalElementDecl(element.localpart);
        }
        return null;
    }
    
    void ensureStackCapacity() {
        if (this.fElementDepth == this.fElemDeclStack.length) {
            int newSize = this.fElementDepth + 8;
            boolean[] newArrayB = new boolean[newSize];
            System.arraycopy(this.fSubElementStack, 0, newArrayB, 0, this.fElementDepth);
            this.fSubElementStack = newArrayB;
            XSElementDecl[] newArrayE = new XSElementDecl[newSize];
            System.arraycopy(this.fElemDeclStack, 0, newArrayE, 0, this.fElementDepth);
            this.fElemDeclStack = newArrayE;
            newArrayB = new boolean[newSize];
            System.arraycopy(this.fNilStack, 0, newArrayB, 0, this.fElementDepth);
            this.fNilStack = newArrayB;
            XSNotationDecl[] newArrayN = new XSNotationDecl[newSize];
            System.arraycopy(this.fNotationStack, 0, newArrayN, 0, this.fElementDepth);
            this.fNotationStack = newArrayN;
            XSTypeDefinition[] newArrayT = new XSTypeDefinition[newSize];
            System.arraycopy(this.fTypeStack, 0, newArrayT, 0, this.fElementDepth);
            this.fTypeStack = newArrayT;
            XSCMValidator[] newArrayC = new XSCMValidator[newSize];
            System.arraycopy(this.fCMStack, 0, newArrayC, 0, this.fElementDepth);
            this.fCMStack = newArrayC;
            newArrayB = new boolean[newSize];
            System.arraycopy(this.fSawTextStack, 0, newArrayB, 0, this.fElementDepth);
            this.fSawTextStack = newArrayB;
            newArrayB = new boolean[newSize];
            System.arraycopy(this.fStringContent, 0, newArrayB, 0, this.fElementDepth);
            this.fStringContent = newArrayB;
            newArrayB = new boolean[newSize];
            System.arraycopy(this.fStrictAssessStack, 0, newArrayB, 0, this.fElementDepth);
            this.fStrictAssessStack = newArrayB;
            int[][] newArrayIA = new int[newSize][];
            System.arraycopy(this.fCMStateStack, 0, newArrayIA, 0, this.fElementDepth);
            this.fCMStateStack = newArrayIA;
        }
    }
    
    void handleStartDocument(XMLLocator locator, String encoding) {
        if (this.fIDCChecking) {
            this.fValueStoreCache.startDocument();
        }
        if (this.fAugPSVI) {
            this.fCurrentPSVI.fGrammars = null;
            this.fCurrentPSVI.fSchemaInformation = null;
        }
    }
    
    void handleEndDocument() {
        if (this.fIDCChecking) {
            this.fValueStoreCache.endDocument();
        }
    }
    
    XMLString handleCharacters(XMLString text) {
        if (this.fSkipValidationDepth >= 0) {
            return text;
        }
        this.fSawText = (this.fSawText || text.length > 0);
        if (this.fNormalizeData && this.fWhiteSpace != -1 && this.fWhiteSpace != 0) {
            this.normalizeWhitespace(text, this.fWhiteSpace == 2);
            text = this.fNormalizedStr;
        }
        if (this.fAppendBuffer) {
            this.fBuffer.append(text.ch, text.offset, text.length);
        }
        this.fSawOnlyWhitespaceInElementContent = false;
        if (this.fCurrentType != null && this.fCurrentType.getTypeCategory() == 15) {
            XSComplexTypeDecl ctype = (XSComplexTypeDecl)this.fCurrentType;
            if (ctype.fContentType == 2) {
                int i = text.offset;
                while (i < text.offset + text.length) {
                    if (!XMLChar.isSpace((int)text.ch[i])) {
                        this.fSawCharacters = true;
                        break;
                    }
                    this.fSawOnlyWhitespaceInElementContent = !this.fSawCharacters;
                    ++i;
                }
            }
        }
        return text;
    }
    
    private void normalizeWhitespace(XMLString value, boolean collapse) {
        boolean skipSpace = collapse;
        boolean sawNonWS = false;
        boolean leading = false;
        boolean trailing = false;
        int size = value.offset + value.length;
        if (this.fNormalizedStr.ch == null || this.fNormalizedStr.ch.length < value.length + 1) {
            this.fNormalizedStr.ch = new char[value.length + 1];
        }
        this.fNormalizedStr.offset = 1;
        this.fNormalizedStr.length = 1;
        for (int i = value.offset; i < size; ++i) {
            char c = value.ch[i];
            if (XMLChar.isSpace((int)c)) {
                if (!skipSpace) {
                    this.fNormalizedStr.ch[this.fNormalizedStr.length++] = ' ';
                    skipSpace = collapse;
                }
                if (!sawNonWS) {
                    leading = true;
                }
            }
            else {
                this.fNormalizedStr.ch[this.fNormalizedStr.length++] = c;
                skipSpace = false;
                sawNonWS = true;
            }
        }
        if (skipSpace) {
            if (this.fNormalizedStr.length > 1) {
                XMLString fNormalizedStr = this.fNormalizedStr;
                --fNormalizedStr.length;
                trailing = true;
            }
            else if (leading && !this.fFirstChunk) {
                trailing = true;
            }
        }
        if (this.fNormalizedStr.length > 1 && !this.fFirstChunk && this.fWhiteSpace == 2) {
            if (this.fTrailing) {
                this.fNormalizedStr.offset = 0;
                this.fNormalizedStr.ch[0] = ' ';
            }
            else if (leading) {
                this.fNormalizedStr.offset = 0;
                this.fNormalizedStr.ch[0] = ' ';
            }
        }
        XMLString fNormalizedStr2 = this.fNormalizedStr;
        fNormalizedStr2.length -= this.fNormalizedStr.offset;
        if ((this.fTrailing = trailing) || sawNonWS) {
            this.fFirstChunk = false;
        }
    }
    
    private void normalizeWhitespace(String value, boolean collapse) {
        boolean skipSpace = collapse;
        int size = value.length();
        if (this.fNormalizedStr.ch == null || this.fNormalizedStr.ch.length < size) {
            this.fNormalizedStr.ch = new char[size];
        }
        this.fNormalizedStr.offset = 0;
        this.fNormalizedStr.length = 0;
        for (int i = 0; i < size; ++i) {
            char c = value.charAt(i);
            if (XMLChar.isSpace((int)c)) {
                if (!skipSpace) {
                    this.fNormalizedStr.ch[this.fNormalizedStr.length++] = ' ';
                    skipSpace = collapse;
                }
            }
            else {
                this.fNormalizedStr.ch[this.fNormalizedStr.length++] = c;
                skipSpace = false;
            }
        }
        if (skipSpace && this.fNormalizedStr.length != 0) {
            XMLString fNormalizedStr = this.fNormalizedStr;
            --fNormalizedStr.length;
        }
    }
    
    void handleIgnorableWhitespace(XMLString text) {
        if (this.fSkipValidationDepth >= 0) {
            return;
        }
        return;
    }
    
    Augmentations handleStartElement(QName element, XMLAttributes attributes, Augmentations augs) {
        if (this.fElementDepth == -1 && this.fValidationManager.isGrammarFound() && this.fSchemaType == null && !this.fUseGrammarPoolOnly) {
            this.fSchemaDynamicValidation = true;
        }
        if (!this.fUseGrammarPoolOnly) {
            String sLocation = attributes.getValue(SchemaSymbols.URI_XSI, SchemaSymbols.XSI_SCHEMALOCATION);
            String nsLocation = attributes.getValue(SchemaSymbols.URI_XSI, SchemaSymbols.XSI_NONAMESPACESCHEMALOCATION);
            this.storeLocations(sLocation, nsLocation);
        }
        if (this.fSkipValidationDepth >= 0) {
            ++this.fElementDepth;
            if (this.fAugPSVI) {
                augs = this.getEmptyAugs(augs);
                return augs;
            }
            return augs;
        }
        else {
            Object decl = null;
            if (this.fCurrentCM != null) {
                decl = this.fCurrentCM.oneTransition(element, this.fCurrCMState, this.fSubGroupHandler);
                if (this.fCurrCMState[0] == -1) {
                    XSComplexTypeDecl ctype = (XSComplexTypeDecl)this.fCurrentType;
                    List<Object> next;
                    if (ctype.fParticle != null && (next = this.fCurrentCM.whatCanGoHere(this.fCurrCMState)).size() > 0) {
                        String expected = this.expectedStr(next);
                        int[] occurenceInfo2 = this.fCurrentCM.occurenceInfo(this.fCurrCMState);
                        String elemExpandedQname = (element.uri != null) ? ("{\"" + element.uri + 34 + ":" + element.localpart + "}") : element.localpart;
                        if (occurenceInfo2 != null) {
                            int minOccurs = occurenceInfo2[0];
                            int maxOccurs2 = occurenceInfo2[1];
                            int count2 = occurenceInfo2[2];
                            if (count2 < minOccurs) {
                                int required = minOccurs - count2;
                                if (required > 1) {
                                    this.reportSchemaError("cvc-complex-type.2.4.h", new Object[] { element.rawname, this.fCurrentCM.getTermName(occurenceInfo2[3]), Integer.toString(minOccurs), Integer.toString(required) });
                                }
                                else {
                                    this.reportSchemaError("cvc-complex-type.2.4.g", new Object[] { element.rawname, this.fCurrentCM.getTermName(occurenceInfo2[3]), Integer.toString(minOccurs) });
                                }
                            }
                            else if (count2 >= maxOccurs2 && maxOccurs2 != -1) {
                                this.reportSchemaError("cvc-complex-type.2.4.e", new Object[] { element.rawname, expected, Integer.toString(maxOccurs2) });
                            }
                            else {
                                this.reportSchemaError("cvc-complex-type.2.4.a", new Object[] { elemExpandedQname, expected });
                            }
                        }
                        else {
                            this.reportSchemaError("cvc-complex-type.2.4.a", new Object[] { elemExpandedQname, expected });
                        }
                    }
                    else {
                        int[] occurenceInfo = this.fCurrentCM.occurenceInfo(this.fCurrCMState);
                        if (occurenceInfo != null) {
                            int maxOccurs = occurenceInfo[1];
                            int count = occurenceInfo[2];
                            if (count >= maxOccurs && maxOccurs != -1) {
                                this.reportSchemaError("cvc-complex-type.2.4.f", new Object[] { this.fCurrentCM.getTermName(occurenceInfo[3]), Integer.toString(maxOccurs) });
                            }
                            else {
                                this.reportSchemaError("cvc-complex-type.2.4.d", new Object[] { element.rawname });
                            }
                        }
                        else {
                            this.reportSchemaError("cvc-complex-type.2.4.d", new Object[] { element.rawname });
                        }
                    }
                }
            }
            if (this.fElementDepth != -1) {
                this.ensureStackCapacity();
                this.fSubElementStack[this.fElementDepth] = true;
                this.fSubElement = false;
                this.fElemDeclStack[this.fElementDepth] = this.fCurrentElemDecl;
                this.fNilStack[this.fElementDepth] = this.fNil;
                this.fNotationStack[this.fElementDepth] = this.fNotation;
                this.fTypeStack[this.fElementDepth] = this.fCurrentType;
                this.fStrictAssessStack[this.fElementDepth] = this.fStrictAssess;
                this.fCMStack[this.fElementDepth] = this.fCurrentCM;
                this.fCMStateStack[this.fElementDepth] = this.fCurrCMState;
                this.fSawTextStack[this.fElementDepth] = this.fSawText;
                this.fStringContent[this.fElementDepth] = this.fSawCharacters;
            }
            ++this.fElementDepth;
            this.fCurrentElemDecl = null;
            XSWildcardDecl wildcard = null;
            this.fCurrentType = null;
            this.fStrictAssess = true;
            this.fNil = false;
            this.fNotation = null;
            this.fBuffer.setLength(0);
            this.fSawText = false;
            this.fSawCharacters = false;
            if (decl != null) {
                if ((decl instanceof XSElementDecl)) {
                    this.fCurrentElemDecl = (XSElementDecl)decl;
                }
                else {
                    wildcard = (XSWildcardDecl)decl;
                }
            }
            if (wildcard != null && wildcard.fProcessContents == 2) {
                this.fSkipValidationDepth = this.fElementDepth;
                if (this.fAugPSVI) {
                    augs = this.getEmptyAugs(augs);
                    return augs;
                }
                return augs;
            }
            else {
                if (this.fElementDepth == 0) {
                    if (this.fRootElementDeclaration != null) {
                        this.checkElementMatchesRootElementDecl(this.fCurrentElemDecl = this.fRootElementDeclaration, element);
                    }
                    else if (this.fRootElementDeclQName != null) {
                        this.processRootElementDeclQName(this.fRootElementDeclQName, element);
                    }
                    else if (this.fRootTypeDefinition != null) {
                        this.fCurrentType = this.fRootTypeDefinition;
                    }
                    else if (this.fRootTypeQName != null) {
                        this.processRootTypeQName(this.fRootTypeQName);
                    }
                }
                if (this.fCurrentType == null) {
                    if (this.fCurrentElemDecl == null) {
                        SchemaGrammar sGrammar = this.findSchemaGrammar((short)5, element.uri, null, element, attributes);
                        if (sGrammar != null) {
                            this.fCurrentElemDecl = sGrammar.getGlobalElementDecl(element.localpart);
                        }
                    }
                    if (this.fCurrentElemDecl != null) {
                        this.fCurrentType = this.fCurrentElemDecl.fType;
                    }
                }
                if (this.fElementDepth == this.fIgnoreXSITypeDepth && this.fCurrentElemDecl == null) {
                    ++this.fIgnoreXSITypeDepth;
                }
                String xsiType = null;
                if (this.fElementDepth >= this.fIgnoreXSITypeDepth) {
                    xsiType = attributes.getValue(SchemaSymbols.URI_XSI, SchemaSymbols.XSI_TYPE);
                }
                if (this.fCurrentType == null && xsiType == null) {
                    if (this.fElementDepth == 0) {
                        if (this.fDynamicValidation || this.fSchemaDynamicValidation) {
                            if (this.fDocumentSource != null) {
                                this.fDocumentSource.setDocumentHandler(this.fDocumentHandler);
                                if (this.fDocumentHandler != null) {
                                    this.fDocumentHandler.setDocumentSource(this.fDocumentSource);
                                }
                                this.fElementDepth = -2;
                                return augs;
                            }
                            else {
                                this.fSkipValidationDepth = this.fElementDepth;
                                if (this.fAugPSVI) {
                                    augs = this.getEmptyAugs(augs);
                                    return augs;
                                }
                                return augs;
                            }
                        }
                        else {
                            this.fXSIErrorReporter.fErrorReporter.reportError("http://www.w3.org/TR/xml-schema-1", "cvc-elt.1.a", new Object[] { element.rawname }, (short)1);
                        }
                    }
                    else if (wildcard != null && wildcard.fProcessContents == 1) {
                        this.reportSchemaError("cvc-complex-type.2.4.c", new Object[] { element.rawname });
                    }
                    this.fCurrentType = SchemaGrammar.fAnyType;
                    this.fStrictAssess = false;
                    this.fNFullValidationDepth = this.fElementDepth;
                    this.fAppendBuffer = false;
                    this.fXSIErrorReporter.pushContext();
                }
                else {
                    this.fXSIErrorReporter.pushContext();
                    if (xsiType != null) {
                        XSTypeDefinition oldType = this.fCurrentType;
                        this.fCurrentType = this.getAndCheckXsiType(element, xsiType, attributes);
                        if (this.fCurrentType == null) {
                            if (oldType == null) {
                                this.fCurrentType = SchemaGrammar.fAnyType;
                            }
                            else {
                                this.fCurrentType = oldType;
                            }
                        }
                    }
                    this.fNNoneValidationDepth = this.fElementDepth;
                    if (this.fCurrentElemDecl != null && this.fCurrentElemDecl.getConstraintType() == 2) {
                        this.fAppendBuffer = true;
                    }
                    else if (this.fCurrentType.getTypeCategory() == 16) {
                        this.fAppendBuffer = true;
                    }
                    else {
                        XSComplexTypeDecl ctype2 = (XSComplexTypeDecl)this.fCurrentType;
                        this.fAppendBuffer = (ctype2.fContentType == 1);
                    }
                }
                if (this.fCurrentElemDecl != null && this.fCurrentElemDecl.getAbstract()) {
                    this.reportSchemaError("cvc-elt.2", new Object[] { element.rawname });
                }
                if (this.fElementDepth == 0) {
                    this.fValidationRoot = element.rawname;
                }
                if (this.fNormalizeData) {
                    this.fFirstChunk = true;
                    this.fTrailing = false;
                    this.fUnionType = false;
                    this.fWhiteSpace = -1;
                }
                if (this.fCurrentType.getTypeCategory() == 15) {
                    XSComplexTypeDecl ctype2 = (XSComplexTypeDecl)this.fCurrentType;
                    if (ctype2.getAbstract()) {
                        this.reportSchemaError("cvc-type.2", new Object[] { element.rawname });
                    }
                    if (this.fNormalizeData && ctype2.fContentType == 1) {
                        if (ctype2.fXSSimpleType.getVariety() == 3) {
                            this.fUnionType = true;
                        }
                        else {
                            try {
                                this.fWhiteSpace = ctype2.fXSSimpleType.getWhitespace();
                            }
                            catch (DatatypeException ex2) {}
                        }
                    }
                }
                else if (this.fNormalizeData) {
                    XSSimpleType dv = (XSSimpleType)this.fCurrentType;
                    if (dv.getVariety() == 3) {
                        this.fUnionType = true;
                    }
                    else {
                        try {
                            this.fWhiteSpace = dv.getWhitespace();
                        }
                        catch (DatatypeException ex) {}
                    }
                }
                this.fCurrentCM = null;
                if (this.fCurrentType.getTypeCategory() == 15) {
                    this.fCurrentCM = ((XSComplexTypeDecl)this.fCurrentType).getContentModel(this.fCMBuilder);
                }
                this.fCurrCMState = null;
                if (this.fCurrentCM != null) {
                    this.fCurrCMState = this.fCurrentCM.startContentModel();
                }
                String xsiNil = attributes.getValue(SchemaSymbols.URI_XSI, SchemaSymbols.XSI_NIL);
                if (xsiNil != null && this.fCurrentElemDecl != null) {
                    this.fNil = this.getXsiNil(element, xsiNil);
                }
                XSAttributeGroupDecl attrGrp = null;
                if (this.fCurrentType.getTypeCategory() == 15) {
                    XSComplexTypeDecl ctype3 = (XSComplexTypeDecl)this.fCurrentType;
                    attrGrp = ctype3.getAttrGrp();
                }
                if (this.fIDCChecking) {
                    this.fValueStoreCache.startElement();
                    this.fMatcherStack.pushContext();
                    if (this.fCurrentElemDecl != null && this.fCurrentElemDecl.fIDCPos > 0) {
                        this.fIdConstraint = true;
                        this.fValueStoreCache.initValueStoresFor(this.fCurrentElemDecl, this);
                    }
                }
                this.processAttributes(element, attributes, attrGrp);
                if (attrGrp != null) {
                    this.addDefaultAttributes(element, attributes, attrGrp);
                }
                for (int count = this.fMatcherStack.getMatcherCount(), i = 0; i < count; ++i) {
                    XPathMatcher matcher = this.fMatcherStack.getMatcherAt(i);
                    matcher.startElement(element, attributes);
                }
                if (this.fAugPSVI) {
                    augs = this.getEmptyAugs(augs);
                    this.fCurrentPSVI.fValidationContext = this.fValidationRoot;
                    this.fCurrentPSVI.fDeclaration = this.fCurrentElemDecl;
                    this.fCurrentPSVI.fTypeDecl = this.fCurrentType;
                    this.fCurrentPSVI.fNotation = this.fNotation;
                    this.fCurrentPSVI.fNil = this.fNil;
                    return augs;
                }
                return augs;
            }
        }
    }
    
    Augmentations handleEndElement(QName element, Augmentations augs) {
        if (this.fSkipValidationDepth >= 0) {
            if (this.fSkipValidationDepth == this.fElementDepth && this.fSkipValidationDepth > 0) {
                this.fNFullValidationDepth = this.fSkipValidationDepth - 1;
                this.fSkipValidationDepth = -1;
                --this.fElementDepth;
                this.fSubElement = this.fSubElementStack[this.fElementDepth];
                this.fCurrentElemDecl = this.fElemDeclStack[this.fElementDepth];
                this.fNil = this.fNilStack[this.fElementDepth];
                this.fNotation = this.fNotationStack[this.fElementDepth];
                this.fCurrentType = this.fTypeStack[this.fElementDepth];
                this.fCurrentCM = this.fCMStack[this.fElementDepth];
                this.fStrictAssess = this.fStrictAssessStack[this.fElementDepth];
                this.fCurrCMState = this.fCMStateStack[this.fElementDepth];
                this.fSawText = this.fSawTextStack[this.fElementDepth];
                this.fSawCharacters = this.fStringContent[this.fElementDepth];
            }
            else {
                --this.fElementDepth;
            }
            if (this.fElementDepth == -1 && this.fFullChecking && !this.fUseGrammarPoolOnly) {
                XSConstraints.fullSchemaChecking(this.fGrammarBucket, this.fSubGroupHandler, this.fCMBuilder, this.fXSIErrorReporter.fErrorReporter);
            }
            if (this.fAugPSVI) {
                augs = this.getEmptyAugs(augs);
                return augs;
            }
            return augs;
        }
        else {
            this.processElementContent(element);
            if (this.fIDCChecking) {
                int oldCount = this.fMatcherStack.getMatcherCount();
                for (int i = oldCount - 1; i >= 0; --i) {
                    XPathMatcher matcher = this.fMatcherStack.getMatcherAt(i);
                    if (this.fCurrentElemDecl == null) {
                        matcher.endElement(element, this.fCurrentType, false, this.fValidatedInfo.actualValue, this.fValidatedInfo.actualValueType, this.fValidatedInfo.itemValueTypes);
                    }
                    else {
                        matcher.endElement(element, this.fCurrentType, this.fCurrentElemDecl.getNillable(), (this.fDefaultValue == null) ? this.fValidatedInfo.actualValue : this.fCurrentElemDecl.fDefault.actualValue, (this.fDefaultValue == null) ? this.fValidatedInfo.actualValueType : this.fCurrentElemDecl.fDefault.actualValueType, (this.fDefaultValue == null) ? this.fValidatedInfo.itemValueTypes : this.fCurrentElemDecl.fDefault.itemValueTypes);
                    }
                }
                if (this.fMatcherStack.size() > 0) {
                    this.fMatcherStack.popContext();
                }
                int newCount = this.fMatcherStack.getMatcherCount();
                for (int j = oldCount - 1; j >= newCount; --j) {
                    XPathMatcher matcher2 = this.fMatcherStack.getMatcherAt(j);
                    if ((matcher2 instanceof Selector.Matcher)) {
                        Selector.Matcher selMatcher = (Selector.Matcher)matcher2;
                        IdentityConstraint id;
                        if ((id = selMatcher.getIdentityConstraint()) != null && id.getCategory() != 2) {
                            this.fValueStoreCache.transplant(id, selMatcher.getInitialDepth());
                        }
                    }
                }
                for (int j = oldCount - 1; j >= newCount; --j) {
                    XPathMatcher matcher2 = this.fMatcherStack.getMatcherAt(j);
                    if ((matcher2 instanceof Selector.Matcher)) {
                        Selector.Matcher selMatcher = (Selector.Matcher)matcher2;
                        IdentityConstraint id;
                        if ((id = selMatcher.getIdentityConstraint()) != null && id.getCategory() == 2) {
                            XMLSchemaValidator.ValueStoreBase values = this.fValueStoreCache.getValueStoreFor(id, selMatcher.getInitialDepth());
                            if (values != null && values.fValuesCount == values.fFieldCount) {
                                values.endDocumentFragment();
                            }
                        }
                    }
                }
                this.fValueStoreCache.endElement();
            }
            if (this.fElementDepth < this.fIgnoreXSITypeDepth) {
                --this.fIgnoreXSITypeDepth;
            }
            SchemaGrammar[] grammars = null;
            if (this.fElementDepth == 0) {
                Iterator<String> invIdRefs = this.fValidationState.checkIDRefID();
                this.fValidationState.resetIDTables();
                if (invIdRefs != null) {
                    while (invIdRefs.hasNext()) {
                        this.reportSchemaError("cvc-id.1", new Object[] { invIdRefs.next() });
                    }
                }
                if (this.fFullChecking && !this.fUseGrammarPoolOnly) {
                    XSConstraints.fullSchemaChecking(this.fGrammarBucket, this.fSubGroupHandler, this.fCMBuilder, this.fXSIErrorReporter.fErrorReporter);
                }
                grammars = this.fGrammarBucket.getGrammars();
                if (this.fGrammarPool != null) {
                    for (int k = 0; k < grammars.length; ++k) {
                        grammars[k].setImmutable(true);
                    }
                    this.fGrammarPool.cacheGrammars("http://www.w3.org/2001/XMLSchema", grammars);
                }
                augs = this.endElementPSVI(true, grammars, augs);
                return augs;
            }
            else {
                augs = this.endElementPSVI(false, grammars, augs);
                --this.fElementDepth;
                this.fSubElement = this.fSubElementStack[this.fElementDepth];
                this.fCurrentElemDecl = this.fElemDeclStack[this.fElementDepth];
                this.fNil = this.fNilStack[this.fElementDepth];
                this.fNotation = this.fNotationStack[this.fElementDepth];
                this.fCurrentType = this.fTypeStack[this.fElementDepth];
                this.fCurrentCM = this.fCMStack[this.fElementDepth];
                this.fStrictAssess = this.fStrictAssessStack[this.fElementDepth];
                this.fCurrCMState = this.fCMStateStack[this.fElementDepth];
                this.fSawText = this.fSawTextStack[this.fElementDepth];
                this.fSawCharacters = this.fStringContent[this.fElementDepth];
                this.fWhiteSpace = -1;
                this.fAppendBuffer = false;
                this.fUnionType = false;
                return augs;
            }
        }
    }
    
    final Augmentations endElementPSVI(boolean root, SchemaGrammar[] grammars, Augmentations augs) {
        if (this.fAugPSVI) {
            augs = this.getEmptyAugs(augs);
            this.fCurrentPSVI.fDeclaration = this.fCurrentElemDecl;
            this.fCurrentPSVI.fTypeDecl = this.fCurrentType;
            this.fCurrentPSVI.fNotation = this.fNotation;
            this.fCurrentPSVI.fValidationContext = this.fValidationRoot;
            this.fCurrentPSVI.fNil = this.fNil;
            if (this.fElementDepth > this.fNFullValidationDepth) {
                this.fCurrentPSVI.fValidationAttempted = 2;
            }
            else if (this.fElementDepth > this.fNNoneValidationDepth) {
                this.fCurrentPSVI.fValidationAttempted = 0;
            }
            else {
                this.fCurrentPSVI.fValidationAttempted = 1;
            }
            if (this.fNFullValidationDepth == this.fElementDepth) {
                this.fNFullValidationDepth = this.fElementDepth - 1;
            }
            if (this.fNNoneValidationDepth == this.fElementDepth) {
                this.fNNoneValidationDepth = this.fElementDepth - 1;
            }
            if (this.fDefaultValue != null) {
                this.fCurrentPSVI.fSpecified = true;
            }
            this.fCurrentPSVI.fValue.copyFrom(this.fValidatedInfo);
            if (this.fStrictAssess) {
                String[] errors = this.fXSIErrorReporter.mergeContext();
                this.fCurrentPSVI.fErrors = errors;
                this.fCurrentPSVI.fValidity = ((errors == null) ? 2 : 1);
            }
            else {
                this.fCurrentPSVI.fValidity = 0;
                this.fXSIErrorReporter.popContext();
            }
            if (root) {
                this.fCurrentPSVI.fGrammars = grammars;
                this.fCurrentPSVI.fSchemaInformation = null;
            }
        }
        return augs;
    }
    
    Augmentations getEmptyAugs(Augmentations augs) {
        if (augs == null) {
            augs = this.fAugmentations;
            augs.removeAllItems();
        }
        augs.putItem("ELEMENT_PSVI", this.fCurrentPSVI);
        this.fCurrentPSVI.reset();
        return augs;
    }
    
    void storeLocations(String sLocation, String nsLocation) {
        if (sLocation != null && !XMLSchemaLoader.tokenizeSchemaLocationStr(sLocation, this.fLocationPairs, (this.fLocator == null) ? null : this.fLocator.getExpandedSystemId())) {
            this.fXSIErrorReporter.reportError("http://www.w3.org/TR/xml-schema-1", "SchemaLocation", new Object[] { sLocation }, (short)0);
        }
        if (nsLocation != null) {
            XMLSchemaLoader.LocationArray la = (XMLSchemaLoader.LocationArray)this.fLocationPairs.get(XMLSymbols.EMPTY_STRING);
            if (la == null) {
                la = new XMLSchemaLoader.LocationArray();
                this.fLocationPairs.put(XMLSymbols.EMPTY_STRING, la);
            }
            if (this.fLocator != null) {
                try {
                    nsLocation = XMLEntityManager.expandSystemId(nsLocation, this.fLocator.getExpandedSystemId(), false);
                }
                catch (URI.MalformedURIException ex) {}
            }
            la.addLocation(nsLocation);
        }
    }
    
    SchemaGrammar findSchemaGrammar(short contextType, String namespace, QName enclosingElement, QName triggeringComponent, XMLAttributes attributes) {
        SchemaGrammar grammar = null;
        grammar = this.fGrammarBucket.getGrammar(namespace);
        if (grammar == null) {
            this.fXSDDescription.setNamespace(namespace);
            if (this.fGrammarPool != null) {
                grammar = (SchemaGrammar)this.fGrammarPool.retrieveGrammar(this.fXSDDescription);
                if (grammar != null && !this.fGrammarBucket.putGrammar(grammar, true, this.fNamespaceGrowth)) {
                    this.fXSIErrorReporter.fErrorReporter.reportError("http://www.w3.org/TR/xml-schema-1", "GrammarConflict", null, (short)0);
                    grammar = null;
                }
            }
        }
        if (!this.fUseGrammarPoolOnly && (grammar == null || (this.fNamespaceGrowth && !this.hasSchemaComponent(grammar, contextType, triggeringComponent)))) {
            this.fXSDDescription.reset();
            this.fXSDDescription.fContextType = contextType;
            this.fXSDDescription.setNamespace(namespace);
            this.fXSDDescription.fEnclosedElementName = enclosingElement;
            this.fXSDDescription.fTriggeringComponent = triggeringComponent;
            this.fXSDDescription.fAttributes = attributes;
            if (this.fLocator != null) {
                this.fXSDDescription.setBaseSystemId(this.fLocator.getExpandedSystemId());
            }
            Map<String, XMLSchemaLoader.LocationArray> locationPairs = this.fLocationPairs;
            XMLSchemaLoader.LocationArray locationArray = (XMLSchemaLoader.LocationArray)locationPairs.get((namespace == null) ? XMLSymbols.EMPTY_STRING : namespace);
            if (locationArray != null) {
                String[] temp = locationArray.getLocationArray();
                if (temp.length != 0) {
                    this.setLocationHints(this.fXSDDescription, temp, grammar);
                }
            }
            if (grammar == null || this.fXSDDescription.fLocationHints != null) {
                boolean toParseSchema = true;
                if (grammar != null) {
                    locationPairs = Collections.emptyMap();
                }
                try {
                    XMLInputSource xis = XMLSchemaLoader.resolveDocument(this.fXSDDescription, locationPairs, this.fEntityResolver);
                    if (grammar != null && this.fNamespaceGrowth) {
                        try {
                            if (grammar.getDocumentLocations().contains(XMLEntityManager.expandSystemId(xis.getSystemId(), xis.getBaseSystemId(), false))) {
                                toParseSchema = false;
                            }
                        }
                        catch (URI.MalformedURIException ex2) {}
                    }
                    if (toParseSchema) {
                        grammar = this.fSchemaLoader.loadSchema(this.fXSDDescription, xis, this.fLocationPairs);
                    }
                }
                catch (IOException ex) {
                    String[] locationHints = this.fXSDDescription.getLocationHints();
                    this.fXSIErrorReporter.fErrorReporter.reportError("http://www.w3.org/TR/xml-schema-1", "schema_reference.4", new Object[] { (locationHints != null) ? locationHints[0] : XMLSymbols.EMPTY_STRING }, (short)0, ex);
                }
            }
        }
        return grammar;
    }
    
    private boolean hasSchemaComponent(SchemaGrammar grammar, short contextType, QName triggeringComponent) {
        if (grammar != null && triggeringComponent != null) {
            String localName = triggeringComponent.localpart;
            if (localName != null && localName.length() > 0) {
                switch (contextType) {
                    case 5: {
                        return grammar.getElementDeclaration(localName) != null;
                    }
                    case 6: {
                        return grammar.getAttributeDeclaration(localName) != null;
                    }
                    case 7: {
                        return grammar.getTypeDefinition(localName) != null;
                    }
                    default: {
                        break;
                    }
                }
            }
        }
        return false;
    }
    
    private void setLocationHints(XSDDescription desc, String[] locations, SchemaGrammar grammar) {
        int length = locations.length;
        if (grammar == null) {
            System.arraycopy(locations, 0, this.fXSDDescription.fLocationHints = new String[length], 0, length);
        }
        else {
            this.setLocationHints(desc, locations, grammar.getDocumentLocations());
        }
    }
    
    private void setLocationHints(XSDDescription desc, String[] locations, StringList docLocations) {
        int length = locations.length;
        String[] hints = new String[length];
        int counter = 0;
        for (int i = 0; i < length; ++i) {
            if (!docLocations.contains(locations[i])) {
                hints[counter++] = locations[i];
            }
        }
        if (counter > 0) {
            if (counter == length) {
                this.fXSDDescription.fLocationHints = hints;
            }
            else {
                System.arraycopy(hints, 0, this.fXSDDescription.fLocationHints = new String[counter], 0, counter);
            }
        }
    }
    
    XSTypeDefinition getAndCheckXsiType(QName element, String xsiType, XMLAttributes attributes) {
        QName typeName = null;
        try {
            typeName = (QName)this.fQNameDV.validate(xsiType, this.fValidationState, null);
        }
        catch (InvalidDatatypeValueException e) {
            this.reportSchemaError(e.getKey(), e.getArgs());
            this.reportSchemaError("cvc-elt.4.1", new Object[] { element.rawname, SchemaSymbols.URI_XSI + "," + SchemaSymbols.XSI_TYPE, xsiType });
            return null;
        }
        XSTypeDefinition type = null;
        if (typeName.uri == SchemaSymbols.URI_SCHEMAFORSCHEMA) {
            type = SchemaGrammar.SG_SchemaNS.getGlobalTypeDecl(typeName.localpart);
        }
        if (type == null) {
            SchemaGrammar grammar = this.findSchemaGrammar((short)7, typeName.uri, element, typeName, attributes);
            if (grammar != null) {
                type = grammar.getGlobalTypeDecl(typeName.localpart);
            }
        }
        if (type == null) {
            this.reportSchemaError("cvc-elt.4.2", new Object[] { element.rawname, xsiType });
            return null;
        }
        if (this.fCurrentType != null) {
            short block = 0;
            if (this.fCurrentElemDecl != null) {
                block = this.fCurrentElemDecl.fBlock;
            }
            if (this.fCurrentType.getTypeCategory() == 15) {
                block |= ((XSComplexTypeDecl)this.fCurrentType).fBlock;
            }
            if (!XSConstraints.checkTypeDerivationOk(type, this.fCurrentType, block)) {
                this.reportSchemaError("cvc-elt.4.3", new Object[] { element.rawname, xsiType, XS10TypeHelper.getSchemaTypeName(this.fCurrentType) });
            }
        }
        return type;
    }
    
    boolean getXsiNil(QName element, String xsiNil) {
        if (this.fCurrentElemDecl != null && !this.fCurrentElemDecl.getNillable()) {
            this.reportSchemaError("cvc-elt.3.1", new Object[] { element.rawname, SchemaSymbols.URI_XSI + "," + SchemaSymbols.XSI_NIL });
        }
        else {
            String value = XMLChar.trim(xsiNil);
            if (value.equals("true") || value.equals("1")) {
                if (this.fCurrentElemDecl != null && this.fCurrentElemDecl.getConstraintType() == 2) {
                    this.reportSchemaError("cvc-elt.3.2.2", new Object[] { element.rawname, SchemaSymbols.URI_XSI + "," + SchemaSymbols.XSI_NIL });
                }
                return true;
            }
        }
        return false;
    }
    
    void processAttributes(QName element, XMLAttributes attributes, XSAttributeGroupDecl attrGrp) {
        String wildcardIDName = null;
        int attCount = attributes.getLength();
        Augmentations augs = null;
        AttributePSVImpl attrPSVI = null;
        boolean isSimple = this.fCurrentType == null || this.fCurrentType.getTypeCategory() == 16;
        XSObjectList attrUses = null;
        int useCount = 0;
        XSWildcardDecl attrWildcard = null;
        if (!isSimple) {
            attrUses = attrGrp.getAttributeUses();
            useCount = attrUses.getLength();
            attrWildcard = attrGrp.fAttributeWC;
        }
        for (int index = 0; index < attCount; ++index) {
            attributes.getName(index, this.fTempQName);
            if (this.fAugPSVI || this.fIdConstraint) {
                augs = attributes.getAugmentations(index);
                attrPSVI = (AttributePSVImpl)augs.getItem("ATTRIBUTE_PSVI");
                if (attrPSVI != null) {
                    attrPSVI.reset();
                }
                else {
                    attrPSVI = new AttributePSVImpl();
                    augs.putItem("ATTRIBUTE_PSVI", attrPSVI);
                }
                attrPSVI.fValidationContext = this.fValidationRoot;
            }
            if (this.fTempQName.uri == SchemaSymbols.URI_XSI) {
                XSAttributeDecl attrDecl = null;
                if (this.fTempQName.localpart == SchemaSymbols.XSI_TYPE) {
                    attrDecl = XMLSchemaValidator.XSI_TYPE;
                }
                else if (this.fTempQName.localpart == SchemaSymbols.XSI_NIL) {
                    attrDecl = XMLSchemaValidator.XSI_NIL;
                }
                else if (this.fTempQName.localpart == SchemaSymbols.XSI_SCHEMALOCATION) {
                    attrDecl = XMLSchemaValidator.XSI_SCHEMALOCATION;
                }
                else if (this.fTempQName.localpart == SchemaSymbols.XSI_NONAMESPACESCHEMALOCATION) {
                    attrDecl = XMLSchemaValidator.XSI_NONAMESPACESCHEMALOCATION;
                }
                if (attrDecl != null) {
                    this.processOneAttribute(element, attributes, index, attrDecl, null, attrPSVI);
                    continue;
                }
            }
            if (this.fTempQName.rawname != XMLSymbols.PREFIX_XMLNS && !this.fTempQName.rawname.startsWith("xmlns:")) {
                if (isSimple) {
                    this.reportSchemaError("cvc-type.3.1.1", new Object[] { element.rawname, this.fTempQName.rawname });
                }
                else {
                    XSAttributeUseImpl currUse = null;
                    int i = 0;
                    while (i < useCount) {
                        XSAttributeUseImpl oneUse = (XSAttributeUseImpl)attrUses.item(i);
                        if (oneUse.fAttrDecl.fName == this.fTempQName.localpart && oneUse.fAttrDecl.fTargetNamespace == this.fTempQName.uri) {
                            currUse = oneUse;
                            break;
                        }
                        ++i;
                    }
                    if (currUse == null && (attrWildcard == null || !attrWildcard.allowNamespace(this.fTempQName.uri))) {
                        this.reportSchemaError("cvc-complex-type.3.2.2", new Object[] { element.rawname, this.fTempQName.rawname });
                        this.fNFullValidationDepth = this.fElementDepth;
                    }
                    else {
                        XSAttributeDecl currDecl = null;
                        if (currUse != null) {
                            currDecl = currUse.fAttrDecl;
                        }
                        else {
                            if (attrWildcard.fProcessContents == 2) {
                                continue;
                            }
                            SchemaGrammar grammar = this.findSchemaGrammar((short)6, this.fTempQName.uri, element, this.fTempQName, attributes);
                            if (grammar != null) {
                                currDecl = grammar.getGlobalAttributeDecl(this.fTempQName.localpart);
                            }
                            if (currDecl == null) {
                                if (attrWildcard.fProcessContents == 1) {
                                    this.reportSchemaError("cvc-complex-type.3.2.2", new Object[] { element.rawname, this.fTempQName.rawname });
                                    continue;
                                }
                                continue;
                            }
                            else if (currDecl.fType.getTypeCategory() == 16 && currDecl.fType.isIDType()) {
                                if (wildcardIDName != null) {
                                    this.reportSchemaError("cvc-complex-type.5.1", new Object[] { element.rawname, currDecl.fName, wildcardIDName });
                                }
                                else {
                                    wildcardIDName = currDecl.fName;
                                }
                            }
                        }
                        this.processOneAttribute(element, attributes, index, currDecl, currUse, attrPSVI);
                    }
                }
            }
        }
        if (!isSimple && attrGrp.fIDAttrName != null && wildcardIDName != null) {
            this.reportSchemaError("cvc-complex-type.5.2", new Object[] { element.rawname, wildcardIDName, attrGrp.fIDAttrName });
        }
    }
    
    void processOneAttribute(QName element, XMLAttributes attributes, int index, XSAttributeDecl currDecl, XSAttributeUseImpl currUse, AttributePSVImpl attrPSVI) {
        String attrValue = attributes.getValue(index);
        this.fXSIErrorReporter.pushContext();
        XSSimpleType attDV = currDecl.fType;
        Object actualValue = null;
        try {
            actualValue = attDV.validate(attrValue, this.fValidationState, this.fValidatedInfo);
            if (this.fNormalizeData) {
                attributes.setValue(index, this.fValidatedInfo.normalizedValue);
            }
            if (attDV.getVariety() == 1 && attDV.getPrimitiveKind() == 20) {
                QName qName = (QName)actualValue;
                SchemaGrammar grammar = this.fGrammarBucket.getGrammar(qName.uri);
                if (grammar != null) {
                    this.fNotation = grammar.getGlobalNotationDecl(qName.localpart);
                }
            }
        }
        catch (InvalidDatatypeValueException idve) {
            this.reportSchemaError(idve.getKey(), idve.getArgs());
            this.reportSchemaError("cvc-attribute.3", new Object[] { element.rawname, this.fTempQName.rawname, attrValue, (attDV instanceof XSSimpleTypeDecl) ? ((XSSimpleTypeDecl)attDV).getTypeName() : attDV.getName() });
        }
        if (actualValue != null && currDecl.getConstraintType() == 2 && (!ValidatedInfo.isComparable(this.fValidatedInfo, currDecl.fDefault) || !actualValue.equals(currDecl.fDefault.actualValue))) {
            this.reportSchemaError("cvc-attribute.4", new Object[] { element.rawname, this.fTempQName.rawname, attrValue, currDecl.fDefault.stringValue() });
        }
        if (actualValue != null && currUse != null && currUse.fConstraintType == 2 && (!ValidatedInfo.isComparable(this.fValidatedInfo, currUse.fDefault) || !actualValue.equals(currUse.fDefault.actualValue))) {
            this.reportSchemaError("cvc-complex-type.3.1", new Object[] { element.rawname, this.fTempQName.rawname, attrValue, currUse.fDefault.stringValue() });
        }
        if (this.fIdConstraint) {
            attrPSVI.fValue.copyFrom(this.fValidatedInfo);
        }
        if (this.fAugPSVI) {
            attrPSVI.fDeclaration = currDecl;
            attrPSVI.fTypeDecl = attDV;
            attrPSVI.fValue.copyFrom(this.fValidatedInfo);
            attrPSVI.fValidationAttempted = 2;
            if (!this.fUseGrammarPoolOnly && (this.fElementDepth >= this.fIgnoreXSITypeDepth || this.fCurrentElemDecl != null)) {
                this.fNNoneValidationDepth = this.fElementDepth;
            }
            String[] errors = this.fXSIErrorReporter.mergeContext();
            attrPSVI.fErrors = errors;
            attrPSVI.fValidity = ((errors == null) ? 2 : 1);
        }
    }
    
    void addDefaultAttributes(QName element, XMLAttributes attributes, XSAttributeGroupDecl attrGrp) {
        XSObjectList attrUses = attrGrp.getAttributeUses();
        for (int useCount = attrUses.getLength(), i = 0; i < useCount; ++i) {
            XSAttributeUseImpl currUse = (XSAttributeUseImpl)attrUses.item(i);
            XSAttributeDecl currDecl = currUse.fAttrDecl;
            short constType = currUse.fConstraintType;
            ValidatedInfo defaultValue = currUse.fDefault;
            if (constType == 0) {
                constType = currDecl.getConstraintType();
                defaultValue = currDecl.fDefault;
            }
            boolean isSpecified = attributes.getValue(currDecl.fTargetNamespace, currDecl.fName) != null;
            if (currUse.fUse == 1 && !isSpecified) {
                this.reportSchemaError("cvc-complex-type.4", new Object[] { element.rawname, currDecl.fName });
            }
            if (!isSpecified && constType != 0) {
                QName attName = new QName(null, currDecl.fName, currDecl.fName, currDecl.fTargetNamespace);
                String normalized = (defaultValue != null) ? defaultValue.stringValue() : "";
                int attrIndex;
                if ((attributes instanceof XMLAttributesImpl)) {
                    XMLAttributesImpl attrs = (XMLAttributesImpl)attributes;
                    attrIndex = attrs.getLength();
                    attrs.addAttributeNS(attName, "CDATA", normalized);
                }
                else {
                    attrIndex = attributes.addAttribute(attName, "CDATA", normalized);
                }
                if (this.fAugPSVI) {
                    Augmentations augs = attributes.getAugmentations(attrIndex);
                    AttributePSVImpl attrPSVI = new AttributePSVImpl();
                    augs.putItem("ATTRIBUTE_PSVI", attrPSVI);
                    attrPSVI.fDeclaration = currDecl;
                    attrPSVI.fTypeDecl = currDecl.fType;
                    attrPSVI.fValue.copyFrom(defaultValue);
                    attrPSVI.fValidationContext = this.fValidationRoot;
                    attrPSVI.fValidity = 2;
                    attrPSVI.fValidationAttempted = 2;
                    attrPSVI.fSpecified = true;
                }
            }
        }
    }
    
    void processElementContent(QName element) {
        if (this.fCurrentElemDecl != null && this.fCurrentElemDecl.fDefault != null && !this.fSawText && !this.fSubElement && !this.fNil) {
            String strv = this.fCurrentElemDecl.fDefault.stringValue();
            int bufLen = strv.length();
            if (this.fNormalizedStr.ch == null || this.fNormalizedStr.ch.length < bufLen) {
                this.fNormalizedStr.ch = new char[bufLen];
            }
            strv.getChars(0, bufLen, this.fNormalizedStr.ch, 0);
            this.fNormalizedStr.offset = 0;
            this.fNormalizedStr.length = bufLen;
            this.fDefaultValue = this.fNormalizedStr;
        }
        this.fValidatedInfo.normalizedValue = null;
        if (this.fNil && (this.fSubElement || this.fSawText)) {
            this.reportSchemaError("cvc-elt.3.2.1", new Object[] { element.rawname, SchemaSymbols.URI_XSI + "," + SchemaSymbols.XSI_NIL });
        }
        this.fValidatedInfo.reset();
        if (this.fCurrentElemDecl != null && this.fCurrentElemDecl.getConstraintType() != 0 && !this.fSubElement && !this.fSawText && !this.fNil) {
            if (this.fCurrentType != this.fCurrentElemDecl.fType && XSConstraints.ElementDefaultValidImmediate(this.fCurrentType, this.fCurrentElemDecl.fDefault.stringValue(), this.fState4XsiType, null) == null) {
                this.reportSchemaError("cvc-elt.5.1.1", new Object[] { element.rawname, this.fCurrentType.getName(), this.fCurrentElemDecl.fDefault.stringValue() });
            }
            this.elementLocallyValidType(element, this.fCurrentElemDecl.fDefault.stringValue());
        }
        else {
            Object actualValue = this.elementLocallyValidType(element, this.fBuffer);
            if (this.fCurrentElemDecl != null && this.fCurrentElemDecl.getConstraintType() == 2 && !this.fNil) {
                String content = this.fBuffer.toString();
                if (this.fSubElement) {
                    this.reportSchemaError("cvc-elt.5.2.2.1", new Object[] { element.rawname });
                }
                if (this.fCurrentType.getTypeCategory() == 15) {
                    XSComplexTypeDecl ctype = (XSComplexTypeDecl)this.fCurrentType;
                    if (ctype.fContentType == 3) {
                        if (!this.fCurrentElemDecl.fDefault.normalizedValue.equals(content)) {
                            this.reportSchemaError("cvc-elt.5.2.2.2.1", new Object[] { element.rawname, content, this.fCurrentElemDecl.fDefault.normalizedValue });
                        }
                    }
                    else if (ctype.fContentType == 1 && actualValue != null && (!ValidatedInfo.isComparable(this.fValidatedInfo, this.fCurrentElemDecl.fDefault) || !actualValue.equals(this.fCurrentElemDecl.fDefault.actualValue))) {
                        this.reportSchemaError("cvc-elt.5.2.2.2.2", new Object[] { element.rawname, content, this.fCurrentElemDecl.fDefault.stringValue() });
                    }
                }
                else if (this.fCurrentType.getTypeCategory() == 16 && actualValue != null && (!ValidatedInfo.isComparable(this.fValidatedInfo, this.fCurrentElemDecl.fDefault) || !actualValue.equals(this.fCurrentElemDecl.fDefault.actualValue))) {
                    this.reportSchemaError("cvc-elt.5.2.2.2.2", new Object[] { element.rawname, content, this.fCurrentElemDecl.fDefault.stringValue() });
                }
            }
        }
        if (this.fDefaultValue == null && this.fNormalizeData && this.fDocumentHandler != null && this.fUnionType) {
            String content2 = this.fValidatedInfo.normalizedValue;
            if (content2 == null) {
                content2 = this.fBuffer.toString();
            }
            int bufLen = content2.length();
            if (this.fNormalizedStr.ch == null || this.fNormalizedStr.ch.length < bufLen) {
                this.fNormalizedStr.ch = new char[bufLen];
            }
            content2.getChars(0, bufLen, this.fNormalizedStr.ch, 0);
            this.fNormalizedStr.offset = 0;
            this.fNormalizedStr.length = bufLen;
            this.fDocumentHandler.characters(this.fNormalizedStr, null);
        }
    }
    
    Object elementLocallyValidType(QName element, Object textContent) {
        if (this.fCurrentType == null) {
            return null;
        }
        Object retValue = null;
        if (this.fCurrentType.getTypeCategory() == 16) {
            if (this.fSubElement) {
                this.reportSchemaError("cvc-type.3.1.2", new Object[] { element.rawname });
            }
            if (!this.fNil) {
                XSSimpleType dv = (XSSimpleType)this.fCurrentType;
                try {
                    if (!this.fNormalizeData || this.fUnionType) {
                        this.fValidationState.setNormalizationRequired(true);
                    }
                    retValue = dv.validate(textContent, this.fValidationState, this.fValidatedInfo);
                }
                catch (InvalidDatatypeValueException e) {
                    this.reportSchemaError(e.getKey(), e.getArgs());
                    this.reportSchemaError("cvc-type.3.1.3", new Object[] { element.rawname, textContent });
                }
            }
        }
        else {
            retValue = this.elementLocallyValidComplexType(element, textContent);
        }
        return retValue;
    }
    
    Object elementLocallyValidComplexType(QName element, Object textContent) {
        Object actualValue = null;
        XSComplexTypeDecl ctype = (XSComplexTypeDecl)this.fCurrentType;
        if (!this.fNil) {
            if (ctype.fContentType == 0 && (this.fSubElement || this.fSawText)) {
                this.reportSchemaError("cvc-complex-type.2.1", new Object[] { element.rawname });
            }
            else if (ctype.fContentType == 1) {
                if (this.fSubElement) {
                    this.reportSchemaError("cvc-complex-type.2.2", new Object[] { element.rawname });
                }
                XSSimpleType dv = ctype.fXSSimpleType;
                try {
                    if (!this.fNormalizeData || this.fUnionType) {
                        this.fValidationState.setNormalizationRequired(true);
                    }
                    actualValue = dv.validate(textContent, this.fValidationState, this.fValidatedInfo);
                }
                catch (InvalidDatatypeValueException e) {
                    this.reportSchemaError(e.getKey(), e.getArgs());
                    this.reportSchemaError("cvc-complex-type.2.2", new Object[] { element.rawname });
                }
            }
            else if (ctype.fContentType == 2 && this.fSawCharacters) {
                this.reportSchemaError("cvc-complex-type.2.3", new Object[] { element.rawname });
            }
            if (ctype.fContentType == 2 || ctype.fContentType == 3) {
                if (this.fCurrCMState[0] >= 0 && !this.fCurrentCM.endContentModel(this.fCurrCMState)) {
                    String expected = this.expectedStr(this.fCurrentCM.whatCanGoHere(this.fCurrCMState));
                    int[] occurenceInfo = this.fCurrentCM.occurenceInfo(this.fCurrCMState);
                    if (occurenceInfo != null) {
                        int minOccurs = occurenceInfo[0];
                        int count = occurenceInfo[2];
                        if (count < minOccurs) {
                            int required = minOccurs - count;
                            if (required > 1) {
                                this.reportSchemaError("cvc-complex-type.2.4.j", new Object[] { element.rawname, this.fCurrentCM.getTermName(occurenceInfo[3]), Integer.toString(minOccurs), Integer.toString(required) });
                            }
                            else {
                                this.reportSchemaError("cvc-complex-type.2.4.i", new Object[] { element.rawname, this.fCurrentCM.getTermName(occurenceInfo[3]), Integer.toString(minOccurs) });
                            }
                        }
                        else {
                            this.reportSchemaError("cvc-complex-type.2.4.b", new Object[] { element.rawname, expected });
                        }
                    }
                    else {
                        this.reportSchemaError("cvc-complex-type.2.4.b", new Object[] { element.rawname, expected });
                    }
                }
                else {
                    List<String> errors = this.fCurrentCM.checkMinMaxBounds();
                    if (errors != null) {
                        for (int i = 0; i < errors.size(); i += 2) {
                            this.reportSchemaError((String)errors.get(i), new Object[] { element.rawname, errors.get(i + 1) });
                        }
                    }
                }
            }
        }
        return actualValue;
    }
    
    void processRootTypeQName(javax.xml.namespace.QName rootTypeQName) {
        String rootTypeNamespace = rootTypeQName.getNamespaceURI();
        rootTypeNamespace = this.fSymbolTable.addSymbol(rootTypeNamespace);
        if (rootTypeNamespace != null && rootTypeNamespace.equals("")) {
            rootTypeNamespace = null;
        }
        if (SchemaSymbols.URI_SCHEMAFORSCHEMA.equals(rootTypeNamespace)) {
            this.fCurrentType = SchemaGrammar.SG_SchemaNS.getGlobalTypeDecl(rootTypeQName.getLocalPart());
        }
        else {
            SchemaGrammar grammarForRootType = this.findSchemaGrammar((short)5, rootTypeNamespace, null, null, null);
            if (grammarForRootType != null) {
                this.fCurrentType = grammarForRootType.getGlobalTypeDecl(rootTypeQName.getLocalPart());
            }
        }
        if (this.fCurrentType == null) {
            String typeName = rootTypeQName.getPrefix().equals("") ? rootTypeQName.getLocalPart() : (rootTypeQName.getPrefix() + ":" + rootTypeQName.getLocalPart());
            this.reportSchemaError("cvc-type.1", new Object[] { typeName });
        }
    }
    
    void processRootElementDeclQName(javax.xml.namespace.QName rootElementDeclQName, QName element) {
        String rootElementDeclNamespace = rootElementDeclQName.getNamespaceURI();
        rootElementDeclNamespace = this.fSymbolTable.addSymbol(rootElementDeclNamespace);
        if (rootElementDeclNamespace != null && rootElementDeclNamespace.equals("")) {
            rootElementDeclNamespace = null;
        }
        SchemaGrammar grammarForRootElement = this.findSchemaGrammar((short)5, rootElementDeclNamespace, null, null, null);
        if (grammarForRootElement != null) {
            this.fCurrentElemDecl = grammarForRootElement.getGlobalElementDecl(rootElementDeclQName.getLocalPart());
        }
        if (this.fCurrentElemDecl == null) {
            String declName = rootElementDeclQName.getPrefix().equals("") ? rootElementDeclQName.getLocalPart() : (rootElementDeclQName.getPrefix() + ":" + rootElementDeclQName.getLocalPart());
            this.reportSchemaError("cvc-elt.1.a", new Object[] { declName });
        }
        else {
            this.checkElementMatchesRootElementDecl(this.fCurrentElemDecl, element);
        }
    }
    
    void checkElementMatchesRootElementDecl(XSElementDecl rootElementDecl, QName element) {
        if (element.localpart != rootElementDecl.fName || element.uri != rootElementDecl.fTargetNamespace) {
            this.reportSchemaError("cvc-elt.1.b", new Object[] { element.rawname, rootElementDecl.fName });
        }
    }
    
    void reportSchemaError(String key, Object[] arguments) {
        if (this.fDoValidation) {
            this.fXSIErrorReporter.reportError("http://www.w3.org/TR/xml-schema-1", key, arguments, (short)1);
        }
    }
    
    private String expectedStr(List<Object> expected) {
        StringBuilder ret = new StringBuilder("{");
        for (int size = expected.size(), i = 0; i < size; ++i) {
            if (i > 0) {
                ret.append(", ");
            }
            ret.append(expected.get(i).toString());
        }
        ret.append('}');
        return ret.toString();
    }
    
    static void access$100(XMLSchemaValidator x0, IdentityConstraint x1) {
        x0.activateSelectorFor(x1);
    }
    
    static {
        RECOGNIZED_FEATURES = new String[] { "http://xml.org/sax/features/validation", "http://apache.org/xml/features/validation/schema", "http://apache.org/xml/features/validation/dynamic", "http://apache.org/xml/features/validation/schema-full-checking", "http://apache.org/xml/features/allow-java-encodings", "http://apache.org/xml/features/continue-after-fatal-error", "http://apache.org/xml/features/standard-uri-conformant", "http://apache.org/xml/features/generate-synthetic-annotations", "http://apache.org/xml/features/validate-annotations", "http://apache.org/xml/features/honour-all-schemaLocations", "http://apache.org/xml/features/internal/validation/schema/use-grammar-pool-only", "http://apache.org/xml/features/validation/schema/ignore-xsi-type-until-elemdecl", "http://apache.org/xml/features/validation/id-idref-checking", "http://apache.org/xml/features/validation/identity-constraint-checking", "http://apache.org/xml/features/validation/unparsed-entity-checking", "http://apache.org/xml/features/namespace-growth", "http://apache.org/xml/features/internal/tolerate-duplicates", "jdk.xml.overrideDefaultParser" };
        FEATURE_DEFAULTS = new Boolean[] { null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, Boolean.valueOf(JdkXmlUtils.OVERRIDE_PARSER_DEFAULT) };
        RECOGNIZED_PROPERTIES = new String[] { "http://apache.org/xml/properties/internal/symbol-table", "http://apache.org/xml/properties/internal/error-reporter", "http://apache.org/xml/properties/internal/entity-resolver", "http://apache.org/xml/properties/internal/validation-manager", "http://apache.org/xml/properties/schema/external-schemaLocation", "http://apache.org/xml/properties/schema/external-noNamespaceSchemaLocation", "http://java.sun.com/xml/jaxp/properties/schemaSource", "http://java.sun.com/xml/jaxp/properties/schemaLanguage", "http://apache.org/xml/properties/validation/schema/root-type-definition", "http://apache.org/xml/properties/validation/schema/root-element-declaration", "http://apache.org/xml/properties/internal/validation/schema/dv-factory", "http://www.oracle.com/xml/jaxp/properties/xmlSecurityPropertyManager" };
        PROPERTY_DEFAULTS = new Object[] { null, null, null, null, null, null, null, null, null, null, null, null };
        XSI_TYPE = SchemaGrammar.SG_XSI.getGlobalAttributeDecl(SchemaSymbols.XSI_TYPE);
        XSI_NIL = SchemaGrammar.SG_XSI.getGlobalAttributeDecl(SchemaSymbols.XSI_NIL);
        XSI_SCHEMALOCATION = SchemaGrammar.SG_XSI.getGlobalAttributeDecl(SchemaSymbols.XSI_SCHEMALOCATION);
        XSI_NONAMESPACESCHEMALOCATION = SchemaGrammar.SG_XSI.getGlobalAttributeDecl(SchemaSymbols.XSI_NONAMESPACESCHEMALOCATION);
    }
    
    protected final class XSIErrorReporter
    {
        XMLErrorReporter fErrorReporter;
        Vector<String> fErrors;
        int[] fContext;
        int fContextCount;
        
        protected XSIErrorReporter() {
            this.fErrors = new Vector();
            this.fContext = new int[8];
        }
        
        public void reset(XMLErrorReporter errorReporter) {
            this.fErrorReporter = errorReporter;
            this.fErrors.removeAllElements();
            this.fContextCount = 0;
        }
        
        public void pushContext() {
            if (!XMLSchemaValidator.this.fAugPSVI) {
                return;
            }
            if (this.fContextCount == this.fContext.length) {
                int newSize = this.fContextCount + 8;
                int[] newArray = new int[newSize];
                System.arraycopy(this.fContext, 0, newArray, 0, this.fContextCount);
                this.fContext = newArray;
            }
            this.fContext[this.fContextCount++] = this.fErrors.size();
            return;
        }
        
        public String[] popContext() {
            if (!XMLSchemaValidator.this.fAugPSVI) {
                return null;
            }
            int[] fContext = this.fContext;
            int fContextCount = this.fContextCount - 1;
            this.fContextCount = fContextCount;
            int contextPos = fContext[fContextCount];
            int size = this.fErrors.size() - contextPos;
            if (size == 0) {
                return null;
            }
            String[] errors = new String[size];
            for (int i = 0; i < size; ++i) {
                errors[i] = (String)this.fErrors.get(contextPos + i);
            }
            this.fErrors.setSize(contextPos);
            return errors;
        }
        
        public String[] mergeContext() {
            if (!XMLSchemaValidator.this.fAugPSVI) {
                return null;
            }
            int[] fContext = this.fContext;
            int fContextCount = this.fContextCount - 1;
            this.fContextCount = fContextCount;
            int contextPos = fContext[fContextCount];
            int size = this.fErrors.size() - contextPos;
            if (size == 0) {
                return null;
            }
            String[] errors = new String[size];
            for (int i = 0; i < size; ++i) {
                errors[i] = (String)this.fErrors.get(contextPos + i);
            }
            return errors;
        }
        
        public void reportError(String domain, String key, Object[] arguments, short severity) throws XNIException {
            String message = this.fErrorReporter.reportError(domain, key, arguments, severity);
            if (XMLSchemaValidator.this.fAugPSVI) {
                this.fErrors.add(key);
                this.fErrors.add(message);
            }
        }
        
        public void reportError(XMLLocator location, String domain, String key, Object[] arguments, short severity) throws XNIException {
            String message = this.fErrorReporter.reportError(location, domain, key, arguments, severity);
            if (XMLSchemaValidator.this.fAugPSVI) {
                this.fErrors.add(key);
                this.fErrors.add(message);
            }
        }
    }
    
    protected static class XPathMatcherStack
    {
        protected XPathMatcher[] fMatchers;
        protected int fMatchersCount;
        protected IntStack fContextStack;
        
        public XPathMatcherStack() {
            this.fMatchers = new XPathMatcher[4];
            this.fContextStack = new IntStack();
        }
        
        public void clear() {
            for (int i = 0; i < this.fMatchersCount; ++i) {
                this.fMatchers[i] = null;
            }
            this.fMatchersCount = 0;
            this.fContextStack.clear();
        }
        
        public int size() {
            return this.fContextStack.size();
        }
        
        public int getMatcherCount() {
            return this.fMatchersCount;
        }
        
        public void addMatcher(XPathMatcher matcher) {
            this.ensureMatcherCapacity();
            this.fMatchers[this.fMatchersCount++] = matcher;
        }
        
        public XPathMatcher getMatcherAt(int index) {
            return this.fMatchers[index];
        }
        
        public void pushContext() {
            this.fContextStack.push(this.fMatchersCount);
        }
        
        public void popContext() {
            this.fMatchersCount = this.fContextStack.pop();
        }
        
        private void ensureMatcherCapacity() {
            if (this.fMatchersCount == this.fMatchers.length) {
                XPathMatcher[] array = new XPathMatcher[this.fMatchers.length * 2];
                System.arraycopy(this.fMatchers, 0, array, 0, this.fMatchers.length);
                this.fMatchers = array;
            }
        }
    }
    
    protected abstract class ValueStoreBase implements ValueStore
    {
        protected IdentityConstraint fIdentityConstraint;
        protected int fFieldCount;
        protected Field[] fFields;
        protected Object[] fLocalValues;
        protected short[] fLocalValueTypes;
        protected ShortList[] fLocalItemValueTypes;
        protected int fValuesCount;
        public final Vector<Object> fValues;
        public XMLSchemaValidator.ShortVector fValueTypes;
        public Vector<ShortList> fItemValueTypes;
        private boolean fUseValueTypeVector;
        private int fValueTypesLength;
        private short fValueType;
        private boolean fUseItemValueTypeVector;
        private int fItemValueTypesLength;
        private ShortList fItemValueType;
        final StringBuilder fTempBuffer;
        
        protected ValueStoreBase(IdentityConstraint identityConstraint) {
            this.fFieldCount = 0;
            this.fFields = null;
            this.fLocalValues = null;
            this.fLocalValueTypes = null;
            this.fLocalItemValueTypes = null;
            this.fValues = new Vector();
            this.fValueTypes = null;
            this.fItemValueTypes = null;
            this.fUseValueTypeVector = false;
            this.fValueTypesLength = 0;
            this.fValueType = 0;
            this.fUseItemValueTypeVector = false;
            this.fItemValueTypesLength = 0;
            this.fItemValueType = null;
            this.fTempBuffer = new StringBuilder();
            this.fIdentityConstraint = identityConstraint;
            this.fFieldCount = this.fIdentityConstraint.getFieldCount();
            this.fFields = new Field[this.fFieldCount];
            this.fLocalValues = new Object[this.fFieldCount];
            this.fLocalValueTypes = new short[this.fFieldCount];
            this.fLocalItemValueTypes = new ShortList[this.fFieldCount];
            for (int i = 0; i < this.fFieldCount; ++i) {
                this.fFields[i] = this.fIdentityConstraint.getFieldAt(i);
            }
        }
        
        public void clear() {
            this.fValuesCount = 0;
            this.fUseValueTypeVector = false;
            this.fValueTypesLength = 0;
            this.fValueType = 0;
            this.fUseItemValueTypeVector = false;
            this.fItemValueTypesLength = 0;
            this.fItemValueType = null;
            this.fValues.setSize(0);
            if (this.fValueTypes != null) {
                this.fValueTypes.clear();
            }
            if (this.fItemValueTypes != null) {
                this.fItemValueTypes.setSize(0);
            }
        }
        
        public void append(XMLSchemaValidator.ValueStoreBase newVal) {
            for (int i = 0; i < newVal.fValues.size(); ++i) {
                this.fValues.add(newVal.fValues.get(i));
            }
        }
        
        public void startValueScope() {
            this.fValuesCount = 0;
            for (int i = 0; i < this.fFieldCount; ++i) {
                this.fLocalValues[i] = null;
                this.fLocalValueTypes[i] = 0;
                this.fLocalItemValueTypes[i] = null;
            }
        }
        
        public void endValueScope() {
            if (this.fValuesCount == 0) {
                if (this.fIdentityConstraint.getCategory() == 1) {
                    String code = "AbsentKeyValue";
                    String eName2 = this.fIdentityConstraint.getElementName();
                    String cName2 = this.fIdentityConstraint.getIdentityConstraintName();
                    XMLSchemaValidator.this.reportSchemaError(code, new Object[] { eName2, cName2 });
                }
                return;
            }
            else if (this.fValuesCount != this.fFieldCount) {
                if (this.fIdentityConstraint.getCategory() == 1) {
                    String code = "KeyNotEnoughValues";
                    UniqueOrKey key = (UniqueOrKey)this.fIdentityConstraint;
                    String eName = this.fIdentityConstraint.getElementName();
                    String cName = key.getIdentityConstraintName();
                    XMLSchemaValidator.this.reportSchemaError(code, new Object[] { eName, cName });
                }
                return;
            }
            else {
                return;
            }
        }
        
        public void endDocumentFragment() {
        }
        
        public void endDocument() {
        }
        
        @Override
        public void reportError(String key, Object[] args) {
            XMLSchemaValidator.this.reportSchemaError(key, args);
        }
        
        @Override
        public void addValue(Field field, boolean mayMatch, Object actualValue, short valueType, ShortList itemValueType) {
            int i;
            for (i = this.fFieldCount - 1; i > -1 && this.fFields[i] != field; --i) {}
            if (i == -1) {
                String code = "UnknownField";
                String eName = this.fIdentityConstraint.getElementName();
                String cName2 = this.fIdentityConstraint.getIdentityConstraintName();
                XMLSchemaValidator.this.reportSchemaError(code, new Object[] { field.toString(), eName, cName2 });
                return;
            }
            if (!mayMatch) {
                String code = "FieldMultipleMatch";
                String cName = this.fIdentityConstraint.getIdentityConstraintName();
                XMLSchemaValidator.this.reportSchemaError(code, new Object[] { field.toString(), cName });
            }
            else {
                ++this.fValuesCount;
            }
            this.fLocalValues[i] = actualValue;
            this.fLocalValueTypes[i] = valueType;
            this.fLocalItemValueTypes[i] = itemValueType;
            if (this.fValuesCount == this.fFieldCount) {
                this.checkDuplicateValues();
                for (i = 0; i < this.fFieldCount; ++i) {
                    this.fValues.add(this.fLocalValues[i]);
                    this.addValueType(this.fLocalValueTypes[i]);
                    this.addItemValueType(this.fLocalItemValueTypes[i]);
                }
            }
            return;
        }
        
        public boolean contains() {
            int next = 0;
            int size = this.fValues.size();
            int i = 0;
        Label_0012:
            while (i < size) {
                next = i + this.fFieldCount;
                int j = 0;
                while (j < this.fFieldCount) {
                    Object value1 = this.fLocalValues[j];
                    Object value2 = this.fValues.get(i);
                    short valueType1 = this.fLocalValueTypes[j];
                    short valueType2 = this.getValueTypeAt(i);
                    Label_0165: {
                        if (value1 != null && value2 != null && valueType1 == valueType2 && value1.equals(value2)) {
                            if (valueType1 == 44 || valueType1 == 43) {
                                ShortList list1 = this.fLocalItemValueTypes[j];
                                ShortList list2 = this.getItemValueTypeAt(i);
                                if (list1 != null && list2 != null) {
                                    if (!list1.equals(list2)) {
                                        break Label_0165;
                                    }
                                }
                                else {
                                    break Label_0165;
                                }
                            }
                            ++i;
                            ++j;
                            continue;
                        }
                    }
                    i = next;
                    continue Label_0012;
                }
                return true;
            }
            return false;
        }
        
        public int contains(XMLSchemaValidator.ValueStoreBase vsb) {
            Vector<Object> values = vsb.fValues;
            int size1 = values.size();
            if (this.fFieldCount <= 1) {
                int l = 0;
                while (l < size1) {
                    short val = vsb.getValueTypeAt(l);
                    if (!this.valueTypeContains(val) || !this.fValues.contains(values.get(l))) {
                        return l;
                    }
                    if (val == 44 || val == 43) {
                        ShortList list3 = vsb.getItemValueTypeAt(l);
                        if (!this.itemValueTypeContains(list3)) {
                            return l;
                        }
                    }
                    ++l;
                }
            }
            else {
                int size2 = this.fValues.size();
                int i = 0;
            Label_0118:
                while (i < size1) {
                    int j = 0;
                Label_0127:
                    while (j < size2) {
                        int k = 0;
                        while (k < this.fFieldCount) {
                            Object value1 = values.get(i + k);
                            Object value2 = this.fValues.get(j + k);
                            short valueType1 = vsb.getValueTypeAt(i + k);
                            short valueType2 = this.getValueTypeAt(j + k);
                            Label_0293: {
                                if (value1 != value2) {
                                    if (valueType1 == valueType2 && value1 != null) {
                                        if (!value1.equals(value2)) {
                                            break Label_0293;
                                        }
                                    }
                                    else {
                                        break Label_0293;
                                    }
                                }
                                if (valueType1 == 44 || valueType1 == 43) {
                                    ShortList list1 = vsb.getItemValueTypeAt(i + k);
                                    ShortList list2 = this.getItemValueTypeAt(j + k);
                                    if (list1 != null && list2 != null) {
                                        if (!list1.equals(list2)) {
                                            break Label_0293;
                                        }
                                    }
                                    else {
                                        break Label_0293;
                                    }
                                }
                                ++k;
                                continue;
                            }
                            j += this.fFieldCount;
                            continue Label_0127;
                        }
                        i += this.fFieldCount;
                        continue Label_0118;
                    }
                    return i;
                }
            }
            return -1;
        }
        
        protected void checkDuplicateValues() {
        }
        
        protected String toString(Object[] values) {
            int size = values.length;
            if (size == 0) {
                return "";
            }
            this.fTempBuffer.setLength(0);
            for (int i = 0; i < size; ++i) {
                if (i > 0) {
                    this.fTempBuffer.append(',');
                }
                this.fTempBuffer.append(values[i]);
            }
            return this.fTempBuffer.toString();
        }
        
        protected String toString(Vector<Object> values, int start, int length) {
            if (length == 0) {
                return "";
            }
            if (length == 1) {
                return String.valueOf(values.get(start));
            }
            StringBuilder str = new StringBuilder();
            for (int i = 0; i < length; ++i) {
                if (i > 0) {
                    str.append(',');
                }
                str.append(values.get(start + i));
            }
            return str.toString();
        }
        
        @Override
        public String toString() {
            String s = super.toString();
            int index1 = s.lastIndexOf(36);
            if (index1 != -1) {
                s = s.substring(index1 + 1);
            }
            int index2 = s.lastIndexOf(46);
            if (index2 != -1) {
                s = s.substring(index2 + 1);
            }
            return s + 91 + this.fIdentityConstraint + 93;
        }
        
        private void addValueType(short type) {
            if (this.fUseValueTypeVector) {
                this.fValueTypes.add(type);
            }
            else if (this.fValueTypesLength++ == 0) {
                this.fValueType = type;
            }
            else if (this.fValueType != type) {
                this.fUseValueTypeVector = true;
                if (this.fValueTypes == null) {
                    this.fValueTypes = new XMLSchemaValidator.ShortVector(this.fValueTypesLength * 2);
                }
                for (int i = 1; i < this.fValueTypesLength; ++i) {
                    this.fValueTypes.add(this.fValueType);
                }
                this.fValueTypes.add(type);
            }
        }
        
        private short getValueTypeAt(int index) {
            if (this.fUseValueTypeVector) {
                return this.fValueTypes.valueAt(index);
            }
            return this.fValueType;
        }
        
        private boolean valueTypeContains(short value) {
            if (this.fUseValueTypeVector) {
                return this.fValueTypes.contains(value);
            }
            return this.fValueType == value;
        }
        
        private void addItemValueType(ShortList itemValueType) {
            if (this.fUseItemValueTypeVector) {
                this.fItemValueTypes.add(itemValueType);
            }
            else if (this.fItemValueTypesLength++ == 0) {
                this.fItemValueType = itemValueType;
            }
            else if (this.fItemValueType != itemValueType && (this.fItemValueType == null || !this.fItemValueType.equals(itemValueType))) {
                this.fUseItemValueTypeVector = true;
                if (this.fItemValueTypes == null) {
                    this.fItemValueTypes = new Vector(this.fItemValueTypesLength * 2);
                }
                for (int i = 1; i < this.fItemValueTypesLength; ++i) {
                    this.fItemValueTypes.add(this.fItemValueType);
                }
                this.fItemValueTypes.add(itemValueType);
            }
        }
        
        private ShortList getItemValueTypeAt(int index) {
            if (this.fUseItemValueTypeVector) {
                return (ShortList)this.fItemValueTypes.get(index);
            }
            return this.fItemValueType;
        }
        
        private boolean itemValueTypeContains(ShortList value) {
            if (this.fUseItemValueTypeVector) {
                return this.fItemValueTypes.contains(value);
            }
            return this.fItemValueType == value || (this.fItemValueType != null && this.fItemValueType.equals(value));
        }
    }
    
    protected class UniqueValueStore extends XMLSchemaValidator.ValueStoreBase
    {
        public UniqueValueStore(UniqueOrKey unique) {
            super(unique);
        }
        
        @Override
        protected void checkDuplicateValues() {
            if (this.contains()) {
                String code = "DuplicateUnique";
                String value = this.toString(this.fLocalValues);
                String eName = this.fIdentityConstraint.getElementName();
                String cName = this.fIdentityConstraint.getIdentityConstraintName();
                XMLSchemaValidator.this.reportSchemaError(code, new Object[] { value, eName, cName });
            }
        }
    }
    
    protected class KeyValueStore extends XMLSchemaValidator.ValueStoreBase
    {
        public KeyValueStore(UniqueOrKey key) {
            super(key);
        }
        
        @Override
        protected void checkDuplicateValues() {
            if (this.contains()) {
                String code = "DuplicateKey";
                String value = this.toString(this.fLocalValues);
                String eName = this.fIdentityConstraint.getElementName();
                String cName = this.fIdentityConstraint.getIdentityConstraintName();
                XMLSchemaValidator.this.reportSchemaError(code, new Object[] { value, eName, cName });
            }
        }
    }
    
    protected class KeyRefValueStore extends XMLSchemaValidator.ValueStoreBase
    {
        protected XMLSchemaValidator.ValueStoreBase fKeyValueStore;
        
        public KeyRefValueStore(KeyRef keyRef, XMLSchemaValidator.KeyValueStore keyValueStore) {
            super(keyRef);
            this.fKeyValueStore = keyValueStore;
        }
        
        @Override
        public void endDocumentFragment() {
            super.endDocumentFragment();
            this.fKeyValueStore = (XMLSchemaValidator.ValueStoreBase)XMLSchemaValidator.this.fValueStoreCache.fGlobalIDConstraintMap.get(((KeyRef)this.fIdentityConstraint).getKey());
            if (this.fKeyValueStore == null) {
                String code2 = "KeyRefOutOfScope";
                String value = this.fIdentityConstraint.toString();
                XMLSchemaValidator.this.reportSchemaError(code2, new Object[] { value });
                return;
            }
            int errorIndex = this.fKeyValueStore.contains(this);
            if (errorIndex != -1) {
                String code = "KeyNotFound";
                String values = this.toString(this.fValues, errorIndex, this.fFieldCount);
                String element = this.fIdentityConstraint.getElementName();
                String name = this.fIdentityConstraint.getName();
                XMLSchemaValidator.this.reportSchemaError(code, new Object[] { name, values, element });
            }
            return;
        }
        
        @Override
        public void endDocument() {
            super.endDocument();
        }
    }
    
    protected class ValueStoreCache
    {
        final XMLSchemaValidator.LocalIDKey fLocalId;
        protected final List<XMLSchemaValidator.ValueStoreBase> fValueStores;
        protected final Map<XMLSchemaValidator.LocalIDKey, XMLSchemaValidator.ValueStoreBase> fIdentityConstraint2ValueStoreMap;
        protected final Stack<Map<IdentityConstraint, XMLSchemaValidator.ValueStoreBase>> fGlobalMapStack;
        protected final Map<IdentityConstraint, XMLSchemaValidator.ValueStoreBase> fGlobalIDConstraintMap;
        
        public ValueStoreCache() {
            this.fLocalId = new XMLSchemaValidator.LocalIDKey();
            this.fValueStores = new ArrayList();
            this.fIdentityConstraint2ValueStoreMap = new HashMap();
            this.fGlobalMapStack = new Stack();
            this.fGlobalIDConstraintMap = new HashMap();
        }
        
        public void startDocument() {
            this.fValueStores.clear();
            this.fIdentityConstraint2ValueStoreMap.clear();
            this.fGlobalIDConstraintMap.clear();
            this.fGlobalMapStack.removeAllElements();
        }
        
        public void startElement() {
            if (this.fGlobalIDConstraintMap.size() > 0) {
                this.fGlobalMapStack.push((Map)((HashMap)this.fGlobalIDConstraintMap).clone());
            }
            else {
                this.fGlobalMapStack.push(null);
            }
            this.fGlobalIDConstraintMap.clear();
        }
        
        public void endElement() {
            if (this.fGlobalMapStack.isEmpty()) {
                return;
            }
            Map<IdentityConstraint, XMLSchemaValidator.ValueStoreBase> oldMap = (Map)this.fGlobalMapStack.pop();
            if (oldMap == null) {
                return;
            }
            for (Map.Entry<IdentityConstraint, XMLSchemaValidator.ValueStoreBase> entry : oldMap.entrySet()) {
                IdentityConstraint id = (IdentityConstraint)entry.getKey();
                XMLSchemaValidator.ValueStoreBase oldVal = (XMLSchemaValidator.ValueStoreBase)entry.getValue();
                if (oldVal != null) {
                    XMLSchemaValidator.ValueStoreBase currVal = (XMLSchemaValidator.ValueStoreBase)this.fGlobalIDConstraintMap.get(id);
                    if (currVal == null) {
                        this.fGlobalIDConstraintMap.put(id, oldVal);
                    }
                    else if (currVal != oldVal) {
                        currVal.append(oldVal);
                    }
                    else {
                        continue;
                    }
                }
                else {
                    continue;
                }
            }
            return;
        }
        
        public void initValueStoresFor(XSElementDecl eDecl, FieldActivator activator) {
            IdentityConstraint[] icArray = eDecl.fIDConstraints;
            for (int icCount = eDecl.fIDCPos, i = 0; i < icCount; ++i) {
                switch (icArray[i].getCategory()) {
                    case 3: {
                        UniqueOrKey unique = (UniqueOrKey)icArray[i];
                        XMLSchemaValidator.LocalIDKey toHash = new XMLSchemaValidator.LocalIDKey(unique, XMLSchemaValidator.this.fElementDepth);
                        XMLSchemaValidator.UniqueValueStore uniqueValueStore = (XMLSchemaValidator.UniqueValueStore)this.fIdentityConstraint2ValueStoreMap.get(toHash);
                        if (uniqueValueStore == null) {
                            uniqueValueStore = new XMLSchemaValidator.UniqueValueStore(unique);
                            this.fIdentityConstraint2ValueStoreMap.put(toHash, uniqueValueStore);
                        }
                        else {
                            uniqueValueStore.clear();
                        }
                        this.fValueStores.add(uniqueValueStore);
                        XMLSchemaValidator.access$100(XMLSchemaValidator.this, icArray[i]);
                        break;
                    }
                    case 1: {
                        UniqueOrKey key = (UniqueOrKey)icArray[i];
                        XMLSchemaValidator.LocalIDKey toHash = new XMLSchemaValidator.LocalIDKey(key, XMLSchemaValidator.this.fElementDepth);
                        XMLSchemaValidator.KeyValueStore keyValueStore = (XMLSchemaValidator.KeyValueStore)this.fIdentityConstraint2ValueStoreMap.get(toHash);
                        if (keyValueStore == null) {
                            keyValueStore = new XMLSchemaValidator.KeyValueStore(key);
                            this.fIdentityConstraint2ValueStoreMap.put(toHash, keyValueStore);
                        }
                        else {
                            keyValueStore.clear();
                        }
                        this.fValueStores.add(keyValueStore);
                        XMLSchemaValidator.access$100(XMLSchemaValidator.this, icArray[i]);
                        break;
                    }
                    case 2: {
                        KeyRef keyRef = (KeyRef)icArray[i];
                        XMLSchemaValidator.LocalIDKey toHash = new XMLSchemaValidator.LocalIDKey(keyRef, XMLSchemaValidator.this.fElementDepth);
                        XMLSchemaValidator.KeyRefValueStore keyRefValueStore = (XMLSchemaValidator.KeyRefValueStore)this.fIdentityConstraint2ValueStoreMap.get(toHash);
                        if (keyRefValueStore == null) {
                            keyRefValueStore = new XMLSchemaValidator.KeyRefValueStore(keyRef, null);
                            this.fIdentityConstraint2ValueStoreMap.put(toHash, keyRefValueStore);
                        }
                        else {
                            keyRefValueStore.clear();
                        }
                        this.fValueStores.add(keyRefValueStore);
                        XMLSchemaValidator.access$100(XMLSchemaValidator.this, icArray[i]);
                        break;
                    }
                }
            }
        }
        
        public XMLSchemaValidator.ValueStoreBase getValueStoreFor(IdentityConstraint id, int initialDepth) {
            this.fLocalId.fDepth = initialDepth;
            this.fLocalId.fId = id;
            return (XMLSchemaValidator.ValueStoreBase)this.fIdentityConstraint2ValueStoreMap.get(this.fLocalId);
        }
        
        public XMLSchemaValidator.ValueStoreBase getGlobalValueStoreFor(IdentityConstraint id) {
            return (XMLSchemaValidator.ValueStoreBase)this.fGlobalIDConstraintMap.get(id);
        }
        
        public void transplant(IdentityConstraint id, int initialDepth) {
            this.fLocalId.fDepth = initialDepth;
            this.fLocalId.fId = id;
            XMLSchemaValidator.ValueStoreBase newVals = (XMLSchemaValidator.ValueStoreBase)this.fIdentityConstraint2ValueStoreMap.get(this.fLocalId);
            if (id.getCategory() == 2) {
                return;
            }
            XMLSchemaValidator.ValueStoreBase currVals = (XMLSchemaValidator.ValueStoreBase)this.fGlobalIDConstraintMap.get(id);
            if (currVals != null) {
                currVals.append(newVals);
                this.fGlobalIDConstraintMap.put(id, currVals);
            }
            else {
                this.fGlobalIDConstraintMap.put(id, newVals);
            }
            return;
        }
        
        public void endDocument() {
            for (XMLSchemaValidator.ValueStoreBase valueStore : this.fValueStores) {
                valueStore.endDocument();
            }
        }
        
        @Override
        public String toString() {
            String s = super.toString();
            int index1 = s.lastIndexOf(36);
            if (index1 != -1) {
                return s.substring(index1 + 1);
            }
            int index2 = s.lastIndexOf(46);
            if (index2 != -1) {
                return s.substring(index2 + 1);
            }
            return s;
        }
    }
    
    protected static final class LocalIDKey
    {
        public IdentityConstraint fId;
        public int fDepth;
        
        public LocalIDKey() {
        }
        
        public LocalIDKey(IdentityConstraint id, int depth) {
            this.fId = id;
            this.fDepth = depth;
        }
        
        @Override
        public int hashCode() {
            return this.fId.hashCode() + this.fDepth;
        }
        
        @Override
        public boolean equals(Object localIDKey) {
            if ((localIDKey instanceof XMLSchemaValidator.LocalIDKey)) {
                XMLSchemaValidator.LocalIDKey lIDKey = (XMLSchemaValidator.LocalIDKey)localIDKey;
                return lIDKey.fId == this.fId && lIDKey.fDepth == this.fDepth;
            }
            return false;
        }
    }
    
    protected static final class ShortVector
    {
        private int fLength;
        private short[] fData;
        
        public ShortVector() {
        }
        
        public ShortVector(int initialCapacity) {
            this.fData = new short[initialCapacity];
        }
        
        public int length() {
            return this.fLength;
        }
        
        public void add(short value) {
            this.ensureCapacity(this.fLength + 1);
            this.fData[this.fLength++] = value;
        }
        
        public short valueAt(int position) {
            return this.fData[position];
        }
        
        public void clear() {
            this.fLength = 0;
        }
        
        public boolean contains(short value) {
            int i = 0;
            while (i < this.fLength) {
                if (this.fData[i] == value) {
                    return true;
                }
                ++i;
            }
            return false;
        }
        
        private void ensureCapacity(int size) {
            if (this.fData == null) {
                this.fData = new short[8];
            }
            else if (this.fData.length <= size) {
                short[] newdata = new short[this.fData.length * 2];
                System.arraycopy(this.fData, 0, newdata, 0, this.fData.length);
                this.fData = newdata;
            }
        }
    }
}
